#include "sGUI\sGUI.bas"
#include once "sGUI\Gadget_DataGrid.bas"
#include once "sGUI\Gadget_SimpleToggle.bas"
#include once "sGUI\Gadget_RadioCheck.bas"
#include once "sGUI\Gadget_FileRequester.bas"
using sGUI

sGUIScreen 20

InitGUI
color Colors.Pen,Colors.BackGround
cls
LoadProportionalFont("Fonts\LiberationSans-Regular_10\LiberationSans-Regular_10.bmp")'allg. Prop-Font
LoadFixedFont("Fonts\LiberationMono-Regular_13\LiberationMono-Regular_13.bmp")'StringGadget
LoadMenuFont("Fonts\LiberationSans-Regular_10\LiberationSans-Regular_10.bmp")'Menfont, DataGrid
dim as sGUIWindow ptr gwin,tbox    
dim as Gadget ptr grid,ar_btn,ac_btn,dr_btn,dc_btn,ru_btn,rd_btn,cl_btn,cr_btn,clr_btn,autow_btn,load_btn,save_btn,em0_rbt,em1_rbt,em2_rbt
dim as Gadget ptr frl,frs
frl=AddFileRequester("Load","Cancel",1)'im FEXISTS-Modus
frs=AddFileRequester("Save","Cancel")
gwin=AddWindow(0,0,0,scrnwidth-sGUIMainSize,scrnheight\2,"windowed DataGrid",WFLAG_FRAMED or WFLAG_DRAGABLE)
grid=AddDataGrid(gwin,0,0,scrnwidth-sGUIMainSize,scrnheight\2)

'mittels "...DataGridHelper\CreateExampleCSV.bas" lassen sich auf die Schnelle (kleine oder sehr groe) Beispiel-CSV-Dateien erzeugen
'CSVLoad(grid,"100x10000.csv")'z.B. diese zu Ladende wre eine solche, msste aber erst erzeugt werden

AddColumn(grid,"Vorname",100)
AddColumn(grid,"Nachname",300)
AddColumn(grid,"Geburtstag",100)
AddRow(grid,10)

SetCell(grid,1,1,"Siglinde")
SetCell(grid,2,1,"Joana")
SetCell(grid,3,1,"Holger")
SetCell(grid,4,1,"Ramses")
SetCell(grid,10,1,"Steffi")
SetCell(grid,1,2,"Meyer...")
SetCell(grid,2,2,"Mueller")
SetCell(grid,3,2,"Schmidt")
SetCell(grid,4,2,"III")
SetCell(grid,10,2,"Prtzschebylski")
SetCell(grid,1,3,"10.10.1937")
SetCell(grid,2,3,"05.04.2000")
SetCell(grid,3,3,"22.09.1969")
SetCell(grid,4,3,"~ 1217 BC")
SetCell(grid,10,3,"21.09.1978")

tbox=AddWindow(0,190,scrnheight\2 + 2*sGUIMainSize,440,130,"DG Tool/Command Box",WFLAG_FRAMED or WFLAG_DRAGABLE)
ar_btn=AddSimpleGadget(tbox,10,10,50,20,"+ Row")
ac_btn=AddSimpleGadget(tbox,70,10,50,20,"+ Clmn")
dr_btn=AddSimpleGadget(tbox,10,40,50,20,"- Row")
dc_btn=AddSimpleGadget(tbox,70,40,50,20,"- Clmn")
clr_btn=AddSimpleGadget(tbox,10,70,50,20,"ClrGrd")
autow_btn=AddSimpleGadget(tbox,70,70,70,20,"AutoWdth")
cl_btn=AddSimpleGadget(tbox,150,40,70,20,"Clmn Lft")
ru_btn=AddSimpleGadget(tbox,190,10,70,20,"Row Up")
rd_btn=AddSimpleGadget(tbox,190,70,70,20,"Row Dwn")
cr_btn=AddSimpleGadget(tbox,230,40,70,20,"Clmn Rgt")
em0_rbt=AddRadioButton(tbox,330,10,"No Edit",0)
em1_rbt=AddRadioButton(tbox,330,35,"Cell Edit",em0_rbt)
em2_rbt=AddRadioButton(tbox,330,60,"Hdr Edit",em0_rbt)
SetSelect(em0_rbt)
load_btn=AddSimpleGadget(tbox,230,100,80,20,"CSVLoad")
save_btn=AddSimpleGadget(tbox,330,100,80,20,"CSVSave")

ShowWindow(tbox)
ShowWindow(gwin)
GadgetOn(grid)      
GadgetOn(ar_btn)
GadgetOn(ac_btn)
GadgetOn(dr_btn)
GadgetOn(dc_btn)
GadgetOn(ru_btn)
GadgetOn(rd_btn)
GadgetOn(cl_btn)
GadgetOn(cr_btn)
GadgetOn(clr_btn)
GadgetOn(autow_btn)
GadgetOn(em0_rbt)
GadgetOn(em1_rbt)
GadgetOn(em2_rbt)
GadgetOn(load_btn)
GadgetOn(save_btn) 

dim as integer selmode,selrow,selcolumn
dim as string filename

locate(30,1)
do
  sleep 1
  MasterControlProgram

  if GADGETMESSAGE then
    select case GADGETMESSAGE
      case grid
        selmode=GetSelectionMode(grid)
        print "Mode:" & selmode & " ... ";
        select case selmode
          case 0'nichts angewhlt
            print "no selection"          
          case 1'Zelle ausgewhlt
            selrow=GetSelectedRow(grid)
            selcolumn=GetSelectedColumn(grid)
            print "Row/Column: " & selrow & "/" & selcolumn & "  Cell: " & GetCell(grid,selrow,selcolumn)                  
          case 2'Zeile ausgewhlt
            selrow=GetSelectedRow(grid)
            print "Row: " & selrow     
          case 4'Spalte ausgewhlt
            selcolumn=GetSelectedColumn(grid)
            print "Column: " & selcolumn                  
        end select

'*****Commands     
      case ar_btn
        AddRow(grid)
      
      case ac_btn
        AddColumn(grid,"Header",150)
        
      case dr_btn
        DelRow(grid,GetSelectedRow(grid))         
      
      case dc_btn
        DelColumn(grid,GetSelectedColumn(grid))
        
      case ru_btn
        RowMove(grid,GetSelectedRow(grid),GetSelectedRow(grid)-1)
        
      case rd_btn
        RowMove(grid,GetSelectedRow(grid),GetSelectedRow(grid)+1)
                             
      case cl_btn
        ColumnMove(grid,GetSelectedColumn(grid), GetSelectedColumn(grid)-1)
      
      case cr_btn
        ColumnMove(grid,GetSelectedColumn(grid), GetSelectedColumn(grid)+1)
     
      case em0_rbt
        SetViewMode(grid)
      
      case em1_rbt
        SetCellEditMode(grid)
      
      case em2_rbt
        SetColumnEditMode(grid)
      
      case autow_btn
        AutoWidth(grid)
      
      case clr_btn
        ClearGrid(grid)
        
      case load_btn
        ShowFileRequester(frl)
      
      case save_btn
        ShowFileRequester(frs)
    
      case frl 
        filename=GetFilerequester(frl)
        if filename<>"" then CSVLoad(grid,filename)

      case frs
        filename=GetFilerequester(frs)
        if filename<>"" then CSVSave(grid,filename)       
      
    end select
  end if
  
loop until SCREENCLOSEBUTTON