#include "sGUI\sGUI.bas"
using sGUI

declare sub SetSliders(entry as integer)
declare sub SetColor (entry as integer) 
declare sub DrawGadgets

sGUIScreenRes 600,600,32
InitGUI
color Colors.Pen,Colors.BackGround
cls

LoadProportionalFont("Fonts\Ubuntu-Medium\Ubuntu-Medium.bmp")
LoadFixedFont("Fonts\Ubuntu-Medium-Mono\Ubuntu-Medium-Mono.bmp")
LoadMenuFont("Fonts\Ubuntu-Light\Ubuntu-Light.bmp")

dim as sGUIWindow ptr win
dim as FB.Image ptr usrimg
win=AddWindow(0,50,75,400,200,"Window",WFLAG_DRAGABLE or WFLAG_FRAMED)
usrimg=GetUserImage(win)

'using three possible GUI fonts with the GUI print routine
'if there is no bitmap font loaded it will use the fb-internal font
'on screen
DrawString 0,30,30,"proportional",&HFF0000,0
DrawString 0,30,60,"mono spaced",&H00DD00,1
DrawString 0,30,90,"menu font",&H00DDDD,2

'in a window user image
paint usrimg,(10,10),&H102030
DrawString usrimg,10,10,"proportional",&HFF0000,0
DrawString usrimg,10,40,"mono spaced",&H00DD00,1
DrawString usrimg,10,70,"menu font",&H00DDDD,2
ShowWindow(win)

'using another non GUI Bitmap font with its own drawing routine
dim as BitmapFont myfont
myfont.LoadFont("Fonts\ArtDeco\ArtDeco.bmp")

myfont.PenColor=&HFFAA00'set pen color
myfont.Print (0,30,120, "Art Deco Font")'print on screen

myfont.PenColor=&H00AAFF'set pen color
myfont.BackGround=&H550000'set background color
myfont.UseBackGround=1'switch on unicolor background
myfont.monospaced=20'if 0 it'll print the font as it was created, otherwise its the fixed char width
myfont.Print (usrimg,10,100, "Another FONT")'print in a window user image


'in this case we need the event loop because we have a window and therefore the GUI has to "run".
do
  sleep 1
  MasterControlProgram
loop until SCREENCLOSEBUTTON