namespace sGUI

declare function AddArrow (win as sGUIWindow ptr,PosX as integer,PosY as integer,DirArrow as integer) as Gadget ptr
declare function ARR_Actions(gad as Gadget ptr,action as integer) as integer
declare sub ARR_Draw (gad as Gadget ptr)
/'
type ARR_Data
	Direction 	as integer
	DelayState 	as integer
  DelayStart  as double
end type
'/
function AddArrow (win as sGUIWindow ptr,PosX as integer,PosY as integer,DirArrow as integer) as Gadget ptr
  function=0  
  dim as Gadget ptr gad
  if win=0 then win=RootWindow
  gad=win->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->parent=win
    gad->Selection=0
    gad->Activation=0
    gad->PosX=PosX
    gad->PosY=PosY
    gad->GadWidth=sGUIMainSize
    gad->GadHeight=sGUIMainSize
    gad->xtd.arr.Direction=DirArrow   
    gad->DrawBuffer->img=imagecreate(gad->GadWidth,Gad->GadHeight,0,32)'by Haubitze       
    gad->DoDraw     =@ARR_Draw
    gad->DoAction   =@ARR_Actions
    gad->DeviceFlags=DFLAG_LMB      
    function=gad
  end if
end function


function ARR_Actions(gad as Gadget ptr,action as integer) as integer
  function=0
  select case action
    case GADGET_LMBHIT
      function=1     
      SetSelect (gad,1)
      
    case GADGET_LMBHOLD
      if gad->xtd.arr.DelayState=2 and timer >= gad->xtd.arr.DelayStart+.05 then
        gad->xtd.arr.DelayStart=timer
        function=1
      end if

      if gad->xtd.arr.DelayState=1 and timer >= gad->xtd.arr.DelayStart+.8 then
        gad->xtd.arr.DelayStart=timer
        gad->xtd.arr.DelayState=2
        function=1
      end if

      if gad->xtd.arr.DelayState=0 then
        gad->xtd.arr.DelayStart=timer
        gad->xtd.arr.DelayState=1
      end if
      SetSelect (gad,1)
      
    case GADGET_LMBHOLDOFF,GADGET_LMBRELEASE,GADGET_LMBRELEASEOFF
      gad->xtd.arr.DelayState=0
      SetSelect (gad,0)     
    
    case GADGET_MOUSEHOVER
      gad->MouseHover=1
    
    case GADGET_MOUSENEXT
      gad->MouseHover=0
  end select
end function


sub ARR_Draw (gad as Gadget ptr)
	dim as integer GadWidth,GadHeight,DirArrow,offset,SymbolSize,a,o
  dim as ulong col
  dim as FB.Image ptr Buffer
	GadWidth =gad->GadWidth
	GadHeight=gad->GadHeight
  DirArrow =gad->xtd.arr.Direction 
  Buffer   =gad->DrawBuffer->img
  SymbolSize=sGUIMainSize * .66
  a=(sGUIMainSize-SymbolSize)/2
  o=( sGUIMainSize - int(SymbolSize/2) ) /2
'OFF 
  ClearBox Buffer,0,0,GadWidth,GadHeight
'ON   unselect/select
  if gad->Activation then
    StdFilledBoxRounded Buffer,0,0,GadWidth,GadHeight,,,gad->Selection,gad->MouseHover
		'unselect/select Symbol   
		if gad->MouseHover then
      col=iif(gad->Selection,Colors.HoverFXTextSelected,Colors.HoverFXText)
    else
			col=iif(gad->Selection,Colors.GadTextSelected,Colors.GadText)
    end if
    
    offset=iif(gad->Selection=1,1,0)
    if DirArrow=0 then Symbol_Arrow Buffer,o-offset,a,SymbolSize,DirArrow,col'l
    if DirArrow=1 then Symbol_Arrow Buffer,o+offset,a,SymbolSize,DirArrow,col'r
    if DirArrow=2 then Symbol_Arrow Buffer,a,o-offset,SymbolSize,DirArrow,col'u
    if DirArrow=3 then Symbol_Arrow Buffer,a,o+offset,SymbolSize,DirArrow,col'd

'SLEEP
    if gad->Activation=2 then Raster Buffer,0,0,GadWidth,GadHeight
  end if
end sub

end namespace
