#include once "Gadget_SimpleToggle.bas"
namespace sGUI

declare function AddParentBtn (win as sGUIWindow ptr,PosX as integer,PosY as integer,GadWidth as integer=0,GadHeight as integer=0) as Gadget ptr
declare sub PBT_Draw (gad as Gadget ptr)
/'
type BTN_Data
  Fire as integer
end type
'/
function AddParentBtn (win as sGUIWindow ptr,PosX as integer,PosY as integer,GadWidth as integer=0,GadHeight as integer=0) as Gadget ptr
	function=0  
	dim as Gadget ptr gad
	if win=0 then win=RootWindow
	gad=win->GadgetList->AppendNew (GadgetType)
	if gad then
		gad->parent=win
		gad->Selection=0
		gad->Activation=0
		gad->PosX=PosX
		gad->PosY=PosY
		gad->GadWidth=GadWidth
		gad->GadHeight=GadHeight  
    gad->DrawBuffer->img=imagecreate(gad->GadWidth,Gad->GadHeight,0,32)'by Haubitze

		gad->DoDraw     =@PBT_Draw
		gad->DoAction   =@BTN_Actions
    gad->DeviceFlags=DFLAG_LMB  
		function=gad
	end if
end function


sub PBT_Draw (gad as Gadget ptr)
	dim as integer GadWidth,GadHeight,ArrowPosX,ArrowPosY
  dim as ulong col
  dim as FB.Image ptr Buffer
  
  GadWidth =gad->GadWidth
	GadHeight=gad->GadHeight
	ArrowPosX =(GadWidth-8)/2
	ArrowPosY =(GadHeight-7)/2
	Buffer   =gad->DrawBuffer->img
  
	'OFF 
	ClearBox Buffer,0,0,GadWidth,GadHeight
'ON   unselect/select
  if gad->Activation then
    StdFilledBoxRounded Buffer,0,0,GadWidth,GadHeight,,,gad->Selection,gad->MouseHover   
    if gad->MouseHover then
      col=iif(gad->Selection,Colors.HoverFXTextSelected,Colors.HoverFXText)     
    else
      col=iif(gad->Selection,Colors.GadTextSelected,Colors.GadText)
    end if
    Symbol_Arrow Buffer,ArrowPosX,ArrowPosY-gad->Selection,9,2,col
		'SLEEP
		if gad->Activation=2 then Raster Buffer,0,0,GadWidth,GadHeight
	end if
end sub

end namespace
