namespace sGUI

declare function AddSimpleGadget (win as sGUIWindow ptr,PosX as integer,PosY as integer,GadWidth as integer=0,GadHeight as integer=0,Text as string) as Gadget ptr
declare function AddToggleGadget (win as sGUIWindow ptr,PosX as integer,PosY as integer,GadWidth as integer=0,GadHeight as integer=0,Text as string) as Gadget ptr
declare function BTN_Actions(gad as Gadget ptr,action as integer) as integer
declare function TGB_Actions(gad as Gadget ptr,action as integer) as integer
declare sub BTN_Draw (gad as Gadget ptr)
/'
type BTN_Data
  Fire as integer
end type
'/
function AddSimpleGadget (win as sGUIWindow ptr,PosX as integer,PosY as integer,GadWidth as integer=0,GadHeight as integer=0,Text as string) as Gadget ptr
	function=0  
	dim as Gadget ptr gad
	if win=0 then win=RootWindow
	gad=win->GadgetList->AppendNew (GadgetType)
	if gad then
		gad->parent=win
		gad->Selection=0
		gad->Activation=0
		gad->PosX=PosX
		gad->PosY=PosY
		if GadWidth=0 then GadWidth=GetTextWidth(Text)+2*sGUIMainGap
		if GadHeight=0 then GadHeight=GetFontHeight+2*sGUIMainGap
		gad->GadWidth=GadWidth
		gad->GadHeight=GadHeight
		gad->Text=Text   
    gad->DrawBuffer->img=imagecreate(gad->GadWidth,Gad->GadHeight)

		gad->DoDraw     =@BTN_Draw
		gad->DoAction   =@BTN_Actions
    gad->DeviceFlags=DFLAG_LMB   
		function=gad
	end if
end function


function AddToggleGadget (win as SGUIWindow ptr,PosX as integer,PosY as integer,GadWidth as integer=0,GadHeight as integer=0,Text as string) as Gadget ptr
	function=0 
	dim as Gadget ptr gad
	gad=AddSimpleGadget (win,PosX,PosY,GadWidth,GadHeight,Text)
	if gad then
		gad->DoAction   =@TGB_Actions    
		function=gad
	end if
end function


function BTN_Actions(gad as Gadget ptr,action as integer) as integer
  function=0
  select case action
    case GADGET_LMBHIT        'Control grad frisch gedrckt
      SetSelect (gad,1)
      if gad->xtd.btn.Fire then function=1'Ping!!!! Control meldet sich: bei mir ist was passiert!!!
      
    case GADGET_LMBHOLD       'Control wird gehalten, Maus ber dem Control
      SetSelect (gad,1)
      if gad->xtd.btn.Fire then function=1'Ping!!!! Control meldet sich: bei mir ist was passiert!!!
    
    case GADGET_LMBHOLDOFF    'Control wird gehalten, Maus neben dem Control
      SetSelect (gad,0)
      if gad->xtd.btn.Fire then function=1'Ping!!!! Control meldet sich: bei mir ist was passiert!!!
      
    case GADGET_LMBRELEASE    'Control regulr losgelassen
      SetSelect (gad,0)
      if gad->xtd.btn.BtnWindow then ShowWindow(gad->xtd.btn.BtnWindow)
      function=1           'Ping!!!! Control meldet sich: bei mir ist was passiert!!!        

    case GADGET_LMBRELEASEOFF 'Control losgelassen, dabei ist Maus neben dem Control
      SetSelect (gad,0)
    
    case GADGET_MOUSEHOVER   'Mouse berm Control
      gad->MouseHover=1
    
    case GADGET_MOUSENEXT   'Mouse vom Control wegbewegt
      gad->MouseHover=0       
  end select
end function


function TGB_Actions(gad as Gadget ptr,action as integer) as integer
  function=0
  select case action
    case GADGET_LMBRELEASE    'Control regulr losgelassen
      SetSelect(gad,iif(GetSelect(gad),0,1))
      function=1
     
    case GADGET_MOUSEHOVER   'Mouse berm Control
      gad->MouseHover=1
    
    case GADGET_MOUSENEXT   'Mouse vom Control wegbewegt
      gad->MouseHover=0 
  end select
end function


sub BTN_Draw (gad as Gadget ptr)
	dim as integer GadWidth,GadHeight,TextPosX,TextPosY
	dim as FB.Image ptr Buffer
	dim as ulong ColorA,ColorB,ColorC,ColorD
  
  GadWidth =gad->GadWidth
	GadHeight=gad->GadHeight
	TextPosX =int((GadWidth-GetTextWidth(gad->Text))/2)
	TextPosY =int((GadHeight-GetFontHeight)/2)
	Buffer   =gad->DrawBuffer->img
  
  if gad->xtd.btn.UseButtonColors then
    ColorA=gad->xtd.btn.GadBody
    ColorB=gad->xtd.btn.GadText
    ColorC=gad->xtd.btn.GadBodySelected 
    ColorD=gad->xtd.btn.GadTextSelected      
  else
    ColorA=Colors.GadBody
    ColorB=Colors.GadText
    ColorC=Colors.GadBodySelected 
    ColorD=Colors.GadTextSelected  
  end if
  
	'OFF 
	ClearBox Buffer,0,0,GadWidth,GadHeight
'ON   unselect/select
  if gad->Activation then
    StdFilledBoxRounded Buffer,0,0,GadWidth,GadHeight,ColorA,ColorC,gad->Selection,gad->MouseHover
		if gad->MouseHover then
      drawstring (Buffer, TextPosX, TextPosY, gad->Text,iif(gad->Selection,Colors.HoverFXTextSelected,Colors.HoverFXText))
    else
			drawstring (Buffer, TextPosX, TextPosY, gad->Text,iif(gad->Selection,ColorD,ColorB))
    end if
		'SLEEP
		if gad->Activation=2 then Raster Buffer,0,0,GadWidth,GadHeight
	end if
end sub

end namespace
