'System Includes
#include once "fbgfx.bi"
#include once "vbcompat.bi"
using FB

namespace sGUI
  #include "external\sGUIList_Custom_pt1.bi"
  #include "external\sGUIList.bi"
  #include "external\sGUIText.bi"
  #include "external\BitmapFont.bi"
  #include "external\ColorInfo.bi"
  #include "sGUI_ColorStorage.bas"'bekomme ich nur dort hin :/

  'Fwd Ref
  type _WinGadHeader      as WinGadHeader
  type _Gadget            as Gadget
  type _sGUIWindow        as sGUIWindow
  'type Gadget            as WinGadHeader
  'type sGUIWindow        as WinGadHeader  
  type _sGUIEntry         as sGUIEntry
  type _sGUIImage         as sGUIImage
  type _BitmapFont        as BitmapFont
  type _ExtendedData      as ExtendedData
  type _sGUIDGColumn      as sGUIDGColumn
  type _sGUIDGCell        as sGUIDGCell
  
  'WindowFlags
  '!!! nicht vergessen, bei Vernderungen an den WFLAGS bitte ValidateFlags() in sGUI_Windows.bas anpassen
  'FensterTyp
  const as ulong WFLAG_IMAGE                  =cast(ulong, 1) shl 0'Imagefenster
  'Buttons & Menu
  const as ulong WFLAG_WINDOWMENU             =cast(ulong, 1) shl 1'Fenster hat ein PullDownMenu
  const as ulong WFLAG_DRAGABLE               =cast(ulong, 1) shl 2'Fenster ist verschiebbar
  const as ulong WFLAG_CLOSEABLE              =cast(ulong, 1) shl 3'Fenster hat nen CloseButton
  const as ulong WFLAG_MINIMISABLE            =cast(ulong, 1) shl 4'!!! Funktion noch nicht eingebaut !!! reserviert fr einen MinimalisierButton
  'GFX Components
  const as ulong WFLAG_FRAMED                 =cast(ulong, 1) shl 5'Fenster mit Rahmen
  const as ulong WFLAG_TITLEBAR               =cast(ulong, 1) shl 6'Fenster mit TitelBalken
  const as ulong WFLAG_MENUBAR                =cast(ulong, 1) shl 7'Fenster mit MenuBalken
  const as ulong WFLAG_NOSHADOW               =cast(ulong, 1) shl 8'Fenster hat kein Schatten
  
  'Stapelverhalten/WARN-GUI-Lock
  const as ulong WFLAG_STACKABLE              =cast(ulong, 1) shl 9'Fenster kann sich im Fensterstapel bewegen, hngt natrlich auch von der Art der anderen Fenster ab
  const as ulong WFLAG_BACKDROP               =cast(ulong, 1) shl 10'Fenster ist immer im Hintergrund
  const as ulong WFLAG_ALWAYSONTOP            =cast(ulong, 1) shl 11'Fenster ist immer oben auf dem Fensterstapel
  const as ulong WFLAG_WARN                   =cast(ulong, 1) shl 12'nur dieses Fenster hat Funktionalitt, die anderen Fenster sind gesperrt
  const as ulong WFLAG_WARNIGNORE             =cast(ulong, 1) shl 13'!!! Funktion noch nicht eingebaut !!! Spezialflag fr DropDownGadget-Windows
  'Focus
  const as ulong WFLAG_PARENTSELECT           =cast(ulong, 1) shl 14'bei Mausklick ins Fenster wird dessen Parent-Window selektiert
  const as ulong WFLAG_NOSELECT               =cast(ulong, 1) shl 15'Fenster geht nicht in den SelektionsModus und ndert auch nicht eine mglich bestehende Selektion eines anderen Fensters  
  'GFX 
  const as ulong WFLAG_APPEARSSELECTED        =cast(ulong, 1) shl 16'unabhngig vom Mausklick, Fenster wird permanent selektiert dargestellt
  const as ulong WFLAG_APPEARSUNSELECTED      =cast(ulong, 1) shl 17'unabhngig vom Mausklick, Fenster wird permanent unselektiert dargestellt

  const as ulong WFLAG_HIDECLICKEDOUTSIDE     =cast(ulong, 1) shl 18'ein Klick ausserhalb des Fensters schliesst es, nur Klicks innerhalb hlt das Fenster geffnet
  const as ulong WFLAG_HIDECLICKEDINSIDE      =cast(ulong, 1) shl 19'ein Klick innerhalb des Fensters schliesst es

  const as ulong WFLAG_DELETEONCLOSE          =cast(ulong, 1) shl 20'wenn gesetzt wird beim Klicken auf den CloseButton das Fenster(und all dessen Childzeugs) real gelscht, vorhandene Zeiger weisen dann ins Nirwana
  const as ulong WFLAG_GADGETMODE             =cast(ulong, 1) shl 21'Replacement fr zusammengesetzte Gadgets
  const as ulong WFLAG_GADGETMODE_LITE        =cast(ulong, 1) shl 22'                    -"-

  'Konstanten fr die Beschreibung des Maustastenstatus
  const as integer HIT=2      'Taste grad frisch gedrckt
  const as integer HOLD=3     'Taste gehalten
  const as integer RELEASE=1  'Taste grad losgelassen
  const as integer RELEASED=0 'Taste ist losgelassen
  'Konstanten Activation
  const as integer ACTIVATION_OFF=0
  const as integer ACTIVATION_ON=1
  const as integer ACTIVATION_SLEEP=2
  
  'DeviceFlags
  const as ulong DFLAG_LMB        =cast(ulong, 1) shl 0
  const as ulong DFLAG_MMB        =cast(ulong, 1) shl 1'unused
  const as ulong DFLAG_RMB        =cast(ulong, 1) shl 2'unused
  const as ulong DFLAG_WHEEL      =cast(ulong, 1) shl 3  
  const as ulong DFLAG_KEYBOARD   =cast(ulong, 1) shl 4
   
  'Konstanten fr die Beschreibung der Ereignisse von Controls
  'LMB
  const as integer GADGET_LMBHIT=1          'Control grad frisch gedrckt
  const as integer GADGET_LMBHOLD=2         'Control wird gehalten, Maus ber dem Control
  const as integer GADGET_LMBHOLDOFF=3      'Control wird gehalten, Maus neben dem Control
  const as integer GADGET_LMBRELEASE=4      'Control regulr losgelassen
  const as integer GADGET_LMBRELEASEOFF=5   'Control losgelassen, dabei ist Maus neben dem Control
  const as integer GADGET_LMBRELEASED=6     'Cleaning       
  'MMB
  const as integer GADGET_MMBHIT=11         'Control grad frisch gedrckt
  const as integer GADGET_MMBHOLD=12        'Control wird gehalten, Maus ber dem Control
  const as integer GADGET_MMBHOLDOFF=13     'Control wird gehalten, Maus neben dem Control
  const as integer GADGET_MMBRELEASE=14     'Control regulr losgelassen
  const as integer GADGET_MMBRELEASEOFF=15  'Control losgelassen, dabei ist Maus neben dem Control
  const as integer GADGET_MMBRELEASED=16    'Cleaning  
  'RMB
  const as integer GADGET_RMBHIT=21         'Control grad frisch gedrckt
  const as integer GADGET_RMBHOLD=22        'Control wird gehalten, Maus ber dem Control
  const as integer GADGET_RMBHOLDOFF=23     'Control wird gehalten, Maus neben dem Control
  const as integer GADGET_RMBRELEASE=24     'Control regulr losgelassen
  const as integer GADGET_RMBRELEASEOFF=25  'Control losgelassen, dabei ist Maus neben dem Control
  const as integer GADGET_RMBRELEASED=26    'Cleaning   
  'Wheel
  const as integer GADGET_WHEELMOVE=31      'Rad wurde bewegt  
  'Keyboard
  const as integer GADGET_KEYBOARD=41       'Keyboardverarbeitung        
  'Highlighting
  const as integer GADGET_MOUSEHOVER=51     'Control ist losgelassen, dabei "schwebt" Maus berm dem Control
  const as integer GADGET_MOUSENEXT =52     'Control ist losgelassen, dabei ist Maus jetzt neben dem Control  
  'TargetOff
  const as integer GADGET_FOCUSOFF =61     'Verhalten dieses Gadgets, falls es nicht mehr das Target ist  
  'Window WFLAG_GADGETMODE Ereignisse
  const as integer WINDOW_MOUSEBUTTONS=1
  const as integer WINDOW_MOUSEWHEEL=2
  const as integer WINDOW_KEYBOARD=3  
  
  'EntryType Konstanten
  const as integer ETYPE_UNDEFINED=0
  const as integer ETYPE_LABEL=1
  const as integer ETYPE_FILE=2
  const as integer ETYPE_DIR=3
  'Men
  const as integer ETYPE_OPENMENUSTRIP=4
  const as integer ETYPE_OPENWINMENUSTRIP=5
  const as integer ETYPE_CLOSEMENUSTRIP=6
  const as integer ETYPE_ITEM=7
  const as integer ETYPE_CHECKMARK=8
  const as integer ETYPE_RADIOBUTTON=9
  const as integer ETYPE_SEPARATOR=10

  'GFX Zeugs
  dim shared as integer ScrnWidth,ScrnHeight'via SCREENINFO
  'GUI interner Standard-Abstand,-Breite
  dim shared as integer sGUIMainGap,sGUIMainSize,BarHeight,MenuBarHeight
  'Eckimages, Schattenimages
  dim shared as _sGUIImage ptr RadioButtonMask
  dim shared as _sGUIImage ptr ShadowLeft,ShadowRight,ShadowTop,ShadowBottom
  dim shared as _sGUIImage ptr ShadowCTL,ShadowCTR,ShadowCBL,ShadowCBR
  dim shared as _sGUIImage ptr BoxCTL,BoxCTR,BoxCBL,BoxCBR
  'etwas Mathe fr Kreisbgen
  dim shared as single rad045,rad090,rad135,rad180,rad225,rad270,rad315
  'Farben
  dim shared as ColorStorage Colors
  dim shared as integer HoverFX,GradientFX,FrameContrastFX
  dim shared as integer BevelFX,FrameFX
  'Font
  dim shared as integer fontheight
  dim shared as _BitmapFont ptr Font_Prop,Font_Mono,Font_Menu

  'System Events
  'Keyboard
  dim shared as string  KEY,tmpkey
  dim shared as integer ASCCODE
  dim shared as integer EXTENDED
  dim shared as integer SCANCODE
  'Maus
  dim shared as integer MOUSEMOVED'idea by Petan
  dim shared as short MOUSEX
  dim shared as short MOUSEY
  dim shared as short MOUSEDELTAX
  dim shared as short MOUSEDELTAY
  dim shared as integer LMB
  dim shared as integer MMB
  dim shared as integer RMB
  dim shared as integer LMB_DOUBLE_CLICK, MMB_DOUBLE_CLICK, RMB_DOUBLE_CLICK
  dim shared as integer WHEEL
  dim shared as integer SCREENCLOSEBUTTON

  'alte Vergleichswerte, in der Regel vom vorherigen Loopdurchlauf
  dim shared as short oldMOUSEX
  dim shared as short oldMOUSEY
  dim shared as integer LMBpressed,MMBpressed,RMBpressed
  dim shared as integer oldLMB
  dim shared as integer oldMMB
  dim shared as integer oldRMB
  dim shared as integer oldWHEEL
  dim shared as integer wheelvalue,oldwheelvalue
  dim shared as integer NEWCLICKSEQUENCE
  'MCP
  dim shared as integer           WARNWARNIGNORE
  dim shared as _Gadget ptr       FOCUSGADGET, MOUSEOVERGADGET
  dim shared as _sGUIWindow ptr   FOCUSWINDOW, MOUSEOVERWINDOW, RefWindow
  'Message System
  dim shared as _Gadget ptr       GADGETMESSAGE
  dim shared as _sGUIWindow ptr   WINDOWMESSAGE, KEYBOARDWINDOW 
  dim shared as integer           MENUID'(integer) ID des Meneintrages, welcher angewhlt wurde
  dim shared as sGUIList ptr      MENUBASE'Zeiger auf die MenuBase des angewhlten Meneintrages
  dim shared as integer           MENUOPEN'FLAG das zeigt, ob irgend ein MenFenster offen ist
  dim shared as _sGUIWindow ptr   STACKREFRESH
  
  'Einstiegspunkt fr den ganzen Bums
  dim shared as _sGUIWindow ptr RootWindow'!!!

  '****Listen ber Listen
  dim shared as sGUIList ptr WindowLists',GadgetWindowList
  dim shared as sGUIList ptr ExtendedActionList,KeyboardGadgetList
  dim shared as sGUIList ptr GadgetLists,ImageList,TextList,EntryLists,PointersLists,MenuGadgetList,MenuWindowList
  dim shared as sGUIList ptr CellLists
  'sGUI Includes
  #include "sGUI_ExtendedData.bas"
  #include "sGUI_SystemEvents.bas"
  #include "sGUI_Font.bas"
  #include "sGUI_Type_sGUIImage.bas"
  #include "sGUI_Type_WindowGadget.bas"
  #include "sGUI_Type_sGUIEntry.bas"
  #include "sGUI_Type_ExtendedAction.bas"
  #include "external\sGUIList_Custom_pt2.bi"
  #include "sGUI_Drawing.bas"
  #include "sGUI_Screen.bas"
  #include "sGUI_MCP.bas"

end namespace

sGUI.rad045 =atn (1)
sGUI.rad090 =sGUI.rad045 * 2
sGUI.rad135 =sGUI.rad045 * 3   
sGUI.rad180 =sGUI.rad045 * 4  
sGUI.rad225 =sGUI.rad045 * 5
sGUI.rad270 =sGUI.rad045 * 6  
sGUI.rad315 =sGUI.rad045 * 7  

sGUI.SCREENCLOSEBUTTON=0
sGUI.NEWCLICKSEQUENCE=0
sGUI.Font_Prop=new sGUI.BitmapFont
sGUI.Font_Mono=new sGUI.BitmapFont
sGUI.Font_Menu=new sGUI.BitmapFont

sGUI.WindowLists=new sGUI.sGUIList
'sGUI.GadgetWindowList=new sGUI.sGUIList
sGUI.GadgetLists=new sGUI.sGUIList
sGUI.ImageList=new sGUI.sGUIList
sGUI.TextList= new sGUI.sGUIList
sGUI.EntryLists= new sGUI.sGUIList
sGUI.PointersLists= new sGUI.sGUIList
sGUI.ExtendedActionList= new sGUI.sGUIList
sGUI.CellLists=new sGUI.sGUIList

sGUI.MenuGadgetList=sGUI.PointersLists->AppendNew (sGUI.sGUIListType)
sGUI.MenuWindowList=sGUI.PointersLists->AppendNew (sGUI.sGUIListType)
sGUI.KeyboardGadgetList=sGUI.PointersLists->AppendNew (sGUI.sGUIListType)

#include once "sGUI_Entry.bas"
#include once "sGUI_Window.bas"
#include once "sGUI_Init.bas"
'******************************************************************************
'******************************************************************************
'allg. Destruktor**************************************************************

sub Maindestructor destructor 
  if sGUI.Font_Prop then delete sGUI.Font_Prop
  if sGUI.Font_Mono then delete sGUI.Font_Mono
  if sGUI.Font_Menu then delete sGUI.Font_Menu 
  if sGUI.WindowLists then delete sGUI.WindowLists
  'if sGUI.GadgetWindowList then delete sGUI.GadgetWindowList
  if sGUI.GadgetLists then delete sGUI.GadgetLists  
  if sGUI.ImageList then delete sGUI.ImageList
  if sGUI.TextList then delete sGUI.TextList
  if sGUI.EntryLists then delete sGUI.EntryLists
	if sGUI.ExtendedActionList then delete sGUI.ExtendedActionList 
  if sGUI.PointersLists then delete sGUI.PointersLists
  if sGUI.CellLists then delete sGUI.CellLists
  'beep' :)<--- it works!!! 
end sub
