declare sub MasterControlProgram (mode as integer=1)

declare sub AlwaysOnTop_Crawler (RefWin as sGUIWindow ptr=Rootwindow)
declare sub BackDropGadgetMode_Crawler (RefWin as sGUIWindow ptr=Rootwindow)
declare sub WarnWarnIgnore_Crawler
declare sub HideClickedOutside_Crawler (RefWin as sGUIWindow ptr=Rootwindow)

declare sub Selection_Crawler (RefWin as sGUIWindow ptr)

declare sub Gadget_Crawler (Win as sGUIWindow ptr=RootWindow, check as integer=1)
declare sub Update_Crawler

declare sub ExtendedActionExecute
declare sub AsParentWindowMessage_Crawler (RefWin as sGUIWindow ptr)

dim as sub (Win as sGUIWindow ptr) MenuHandlerCall

declare sub DrawScreen
declare sub GUIBuild_PutGadgetImage (Win as sGUIWindow ptr, ChildGad as Gadget ptr, ThisImage as FB.Image ptr)
declare sub GUIBuild_Crawler(Win as sGUIWindow ptr)
declare sub Hover_Crawler(Win as sGUIWindow ptr)
declare sub DrawGadgets_Crawler

declare sub GetHoveredObjects(byref Win as sGUIWindow ptr, byref Gad as Gadget ptr)
declare function IsChildOf(parentwin as sGUIWindow ptr, child as any ptr) as integer
declare function GetWindowPointer(Win as sGUIWindow ptr=RootWindow, wwi as integer=WARNWARNIGNORE) as sGUIWindow ptr
declare sub WarnWarnIgnoreCheck


sub MasterControlProgram (mode as integer=1) 
  GetSysEvents
  GADGETMESSAGE=0
  WINDOWMESSAGE=0
  MENUBASE=0
  MENUID=0  
  'grundstzlich wird jeden Schleifendurchgang geprft ob ein WARN/WARNIGNORE-Fenster offen ist. Wenn ja, dann ist die globale Variable WARNWARNIGNORE=1
  WarnWarnIgnoreCheck  
  'in jedem Schleifendurchgang wird das Fenster ermittelt, ber welchem die Maus schwebt
  'MOUSEOVERWINDOW kann auch 0 sein, wenn WARNWARNIGNORE gesetzt ist, dann GUI-Lock ausser entsprechende Fenster
  MOUSEOVERWINDOW=GetWindowPointer

  if LMB=HIT then RefWindow=MOUSEOVERWINDOW
  
  'LMB Klick im Referenzfenster
  if RefWindow then
    select case LMB
      case HIT
        HideClickedOutside_Crawler(RefWindow)
        
        Gadget_Crawler(RefWindow,1)
        if (MenuHandlerCall<>0) then MenuHandlerCall(RefWindow)' der komplette Menhandler
               
        Selection_Crawler(RefWindow)'Selektionsstatus aller offenen Fenster prfen/setzen      
        'Stapelhandle    
        'falls Referenzfenster WFLAG_STACKABLE ist, erstmal nach oben damit
        if RefWindow<>Rootwindow then 
          if (RefWindow->WinFlags and WFLAG_STACKABLE) then cast(sGUIWindow ptr,RefWindow->Parent)->WindowList->MoveToLast(RefWindow) 
        end if         
      
      case HOLD
        Gadget_Crawler(RefWindow,1)
      
      case RELEASE
        'if MOUSEOVERWINDOW=RefWindow then FOCUSWINDOW=RefWindow      
        Gadget_Crawler(RefWindow,1)

      
      case RELEASED
        Gadget_Crawler(RefWindow,1)       
        if (RefWindow->WinFlags and WFLAG_HIDECLICKEDINSIDE) then RefWindow->Activation=0
        if RefWindow then RefWindow=0
    end select
    
    'WinStack
    BackDropGadgetMode_Crawler
    AlwaysOnTop_Crawler
    WarnWarnIgnore_Crawler'nur im Loop ausfhren, wenn WARN/WARNIGNORE offen ist        
  end if
  
  'stndig 
  if WHEEL then Gadget_Crawler(MOUSEOVERWINDOW,2)' 2=Wheel Check  
  if KEY<>"" then Gadget_Crawler(FOCUSWINDOW,3)' 3=Keyboard Check
  
  Update_Crawler'geht durch jedes(!) Gadget und ruft, so es denn eine gibt, dessen Update-Routine auf  
  ExtendedActionExecute 
  if HoverFX then Hover_Crawler(MOUSEOVERWINDOW)    
  if WINDOWMESSAGE then AsParentWindowMessage_Crawler (WINDOWMESSAGE)
  '********* Rest ;)
  if mode then DrawScreen 
end sub


'******************************************************************************
'******************************************************************************
'******************************************************************************
'Fenster: Stapel, Selektion


sub AlwaysOnTop_Crawler(RefWin as sGUIWindow ptr=Rootwindow)
  dim as _sGUIWindow ptr ChildWin,listwin
  dim as sGUIList ptr AlwaysOnTopList,Lst
  dim as node ptr n
  ChildWin=RefWin->WindowList->GetFirst
  if ChildWin then   
    'alle ChildWindows mit entsprechenden Flag in einer "einfachen" Liste (nur nodes) sammeln
    AlwaysOnTopList=PointersLists->AppendNew (sGUIListType)         

    do
      if (ChildWin->WinFlags and WFLAG_ALWAYSONTOP) then       
        n=AlwaysOnTopList->AppendNew (nodeType)
        n->anypointer=cast(any ptr,ChildWin)
      end if
      ChildWin=cast(sGUIWindow ptr,ChildWin->next_node)        
    loop until ChildWin=0
    
    'gesammelte Fenster entsprechend im Stapel verschieben
    n=AlwaysOnTopList->GetFirst
    if n then
      do            
        RefWin->WindowList->MoveToLast( cast(sGUIWindow ptr, n->anypointer)  )        
        n=cast(node ptr,n->next_node)
      loop until n=0
    end if       
    'PointerListe lschen
    PointersLists->DeleteNode(AlwaysOnTopList)     
   
    'rekursiver Aufruf dieser Routine bei allen ChildWindows dieses Fensters
    'somit werden alle Fenster dieses Zweiges behandelt
    'dies knnen alle Fenster sein, ausgehend vom Rootwindow, muss es aber nicht
    ChildWin=RefWin->WindowList->GetFirst
    do            
      if ChildWin->Activation=1 then AlwaysOnTop_Crawler (ChildWin)        
      ChildWin=cast(sGUIWindow ptr,ChildWin->next_node)           
    loop until ChildWin=0         
  end if
end sub


sub BackDropGadgetMode_Crawler(RefWin as sGUIWindow ptr=Rootwindow)
  dim as _sGUIWindow ptr ChildWin,listwin
  dim as sGUIList ptr BackDropList,GadgetModeList,Lst
  dim as node ptr n
  ChildWin=RefWin->WindowList->GetLast'<-! im Gegensatz zu ALWAYSONTOP hier umgekehrte Suche
  if ChildWin then   
    'alle ChildWindows mit entsprechenden Flag in zwei "einfachen" Listen (nur nodes) sammeln
    BackDropList=PointersLists->AppendNew (sGUIListType)
    GadgetModeList=PointersLists->AppendNew (sGUIListType)
    do
      if (ChildWin->WinFlags and WFLAG_BACKDROP) then       
        n=BackDropList->AppendNew (nodeType)
        n->anypointer=cast(any ptr,ChildWin)
      end if
      if (ChildWin->WinFlags and WFLAG_GADGETMODE) then       
        n=GadgetModeList->AppendNew (nodeType)
        n->anypointer=cast(any ptr,ChildWin)
      end if        
      ChildWin=cast(sGUIWindow ptr,ChildWin->prev_node)'<-!revers again        
    loop until ChildWin=0
      
    'gesammelte Fenster entsprechend im Stapel verschieben
    Lst=BackDropList
    do
      n=Lst->GetFirst
      if n then
        do            
          RefWin->WindowList->MoveToFirst( cast(sGUIWindow ptr, n->anypointer)  )'<-!revers again again        
          n=cast(node ptr,n->next_node)
        loop until n=0     
      end if       
      lst=iif(Lst=BackDropList,GadgetModeList,0)'Listenwechsel bzw mit 0 Abbruchbedingung fr ussere DO...LOOP
    loop until Lst=0
    'PointerListen lschen
    PointersLists->DeleteNode(BackDropList)
    PointersLists->DeleteNode(GadgetModeList)      
    
    'rekursiver Aufruf dieser Routine bei allen ChildWindows dieses Fensters
    'somit werden alle Fenster dieses Zweiges behandelt
    'dies knnen alle Fenster sein, dann ausgehend vom Rootwindow, muss es aber nicht
    ChildWin=RefWin->WindowList->GetFirst
    do            
      if ChildWin->Activation=1 then BackDropGadgetMode_Crawler (ChildWin)        
      ChildWin=cast(sGUIWindow ptr,ChildWin->next_node)           
    loop until ChildWin=0         
  end if
end sub


sub WarnWarnIgnore_Crawler
  dim as _sGUIWindow ptr ChildWin,listwin
  dim as sGUIList ptr WList,WIList,Lst
  dim as node ptr n
  if WARNWARNIGNORE then
    ChildWin=RootWindow->WindowList->GetFirst
    if ChildWin then   
      'alle ChildWindows mit entsprechenden Flag in zwei "einfachen" Liste (nur nodes) sammeln
      WList=PointersLists->AppendNew (sGUIListType)
      WIList=PointersLists->AppendNew (sGUIListType)
      do
        if (ChildWin->WinFlags and WFLAG_WARN) then       
          n=WList->AppendNew (nodeType)
          n->anypointer=cast(any ptr,ChildWin)
        end if
        if (ChildWin->WinFlags and WFLAG_WARNIGNORE) then       
          n=WIList->AppendNew (nodeType)
          n->anypointer=cast(any ptr,ChildWin)
        end if        
        ChildWin=cast(sGUIWindow ptr,ChildWin->next_node)        
      loop until ChildWin=0
      
      'erst WARN, danach WARNIGNORE
      Lst=WList
      do
        n=Lst->GetFirst
        if n then
          do            
            RootWindow->WindowList->MoveToLast( cast(sGUIWindow ptr, n->anypointer) )      
            n=cast(node ptr,n->next_node)
          loop until n=0     
        end if       
        lst=iif(Lst=WList,WIList,0)'Listenwechsel bzw mit 0 Abbruchbedingung fr ussere DO...LOOP
      loop until Lst=0
     
      'PointerListen lschen
      PointersLists->DeleteNode(WList)
      PointersLists->DeleteNode(WIList)        
    end if
  end if
end sub


sub HideClickedOutside_Crawler(RefWin as sGUIWindow ptr=Rootwindow)
  dim as _sGUIWindow ptr win
  dim as sGUIList ptr Lst
  'RefWin kann auch ein ChildWindow eines HIDECLICKEDOUTSIDE-Fensters sein und muss nicht zwingend selbst dieses Flag aufweisen
  'wenn dies der Fall ist, muss zuerst bis hin zum RootWindow untersucht werden, ob bei seinen Parents irgendwo dieses Flag auftritt, 
  'dies ist dann das "eigentliche" RefWin!
  'falls keines gefunden wurde, war der Klick definitiv irgendwo "outside" 
  if RefWin<>RootWindow then
    if (RefWin->WinFlags and WFLAG_HIDECLICKEDOUTSIDE)=0 then'falls RefWin KEIN HIDECLICKEDOUTSIDE-Fenster ist
      Win=RefWin
      do
        if (Win->WinFlags and WFLAG_HIDECLICKEDOUTSIDE) then RefWin=Win 
        Win=cast(sGUIWindow ptr, Win)->Parent
      loop until Win=RootWindow'Abbruch wenn RootWindow erreicht
    end if
  end if
  
  Lst=WindowLists->GetFirst
  if Lst then
    do
      win=Lst->GetFirst
      if win then
        do
          if (win<>RefWin) then
            'schliesse alle AUTOHIDE-Fenster mit Ausnahme des Referenzfensters, denn in dieses wurde ja geklickt
            if (win->WinFlags and WFLAG_HIDECLICKEDOUTSIDE) then win->Activation=0
          end if
          win=cast(sGUIWindow ptr,win->next_node)
        loop until win=0
      end if
      Lst=cast(sGUIList ptr,Lst->next_node)
    loop until Lst=0
  end if
end sub


'behandelt WFLAG_GADGETMODE, WFLAG_PARENTSELECT, WFLAG_NOSELECT oder "normale" Selektion eines Fensters
sub Selection_Crawler (RefWin as sGUIWindow ptr)
  dim as sGUIList ptr Lst
  dim as sGUIWindow ptr Win,ParentWin
  dim as ulong flag,caseflag
  'sollte "Einstiegsfenster" ein GADGETMODE-Fenster sein
  'dann durch seine Parents "hangeln" bis erstes NICHT-GADGETMODE-Fenster gefunden wurde
  Win=RefWin
  if (Win->WinFlags and WFLAG_GADGETMODE) then
    do
      ParentWin=cast(sGUIWindow ptr, Win)->Parent
      flag=(ParentWin->WinFlags and WFLAG_GADGETMODE)
      Win=ParentWin
    loop until flag=0'Abbruch wenn ein Parent NICHT das WFLAG_GADGETMODE hat
    'das gefundene NICHT-WFLAG_GADGETMODE-Fenster wird zum RefWin (Sub-intern)
    RefWin=Win
  end if
  
  'per RegelWerk darf ein Fenster entweder WFLAG_PARENTSELECT oder WFLAG_NOSELECT (nur eines von beiden !) oder KEINES der beiden haben, also drei Mglichkeiten
  'die 3. Mglichkeit sieht man hier nicht direkt: wenn WFLAG_NOSELECT gesetzt wurde, finden die beiden anderen Cases einfach nicht statt, 
  'und genau dies ist Mglichkeit Nr 3!!!
  caseflag=(WFLAG_PARENTSELECT or WFLAG_NOSELECT ) and RefWin->WinFlags  
  select case caseflag
  
    case 0'bedeutet gleichzeitig auch kein WFLAG_NOSELECT Bit gesetzt!
      '"normale" Selektion des RefWin, alle anderen Selektionen werden aufgehoben
      Lst=WindowLists->GetFirst
      if Lst then
        do
          Win=Lst->GetFirst
          if Win then
            do
              if Win->Activation then
                Win->Selection=iif(Win=RefWin,1,0)
              end if
              Win=cast(sGUIWindow ptr,Win->next_node)
            loop until Win=0
          end if
          Lst=cast(sGUIList ptr,Lst->next_node)
        loop until Lst=0
      end if     
    
    case WFLAG_PARENTSELECT
      flag=caseflag' Win->WinFlags and WFLAG_PARENTSELECT
      if Win->Selection then
        do
          if (flag<>0) and (Win->Selection=1) then 
            Win->Selection=0
            Win=cast(sGUIWindow ptr,Win->Parent)
            if (Win>0) and (Win<>RootWindow) then
              Win->Selection=1
              flag=Win->WinFlags and WFLAG_PARENTSELECT
            end if
          end if                     
        loop until (flag=0) or (Win=0)
      end if
      
  end select
end sub


'******************************************************************************
'******************************************************************************
'******************************************************************************
'Gadget


sub  Gadget_Crawler (Win as sGUIWindow ptr=RootWindow, check as integer=1)
  dim as sGUIWindow ptr ParentWin
  dim as ulong flags,GMfilter
  GMfilter=WFLAG_GADGETMODE or WFLAG_GADGETMODE_LITE
  if Win then
    
    GADGETMESSAGE=0
    WINDOWMESSAGE=0
    'Gadgets erzeugen jetzt und ohne Umweg eine globale GADGETMESSAGE
    select case check
      case 1
        Win->LMBGadgetCheck      
      case 2
        Win->WheelGadgetCheck
      case 3
        Win->KeyboardGadgetCheck      
    end select

    'NEU, prfen ob das Fenster WFLAG_GADGETMODE(_LITE) gesetzt hat dann dessen DoAction() aufrufen  
    'ab jetzt nur noch Reaktion auf eine globale GADGETMESSAGE
    'auch Win->DoAction() wertet und modifiziert nur noch die globale GADGETMESSAGE aus 
    if (Win->WinFlags and GMfilter) then
      'bei zusammengesetzten WFLAG_GADGETMODE Fenstern die GADGETMESSAGE-Ereignisse nach "oben" durchreichen, bis das letzte Parent(Wurzel?) dieses Zweiges erreicht ist  
      do
        Win->DoAction (win)        
        ParentWin=cast(sGUIWindow ptr, Win)->Parent
        flags=(ParentWin->WinFlags and GMfilter)
        Win=ParentWin
      loop until flags=0'Abbruch wenn ein Parent NICHT das WFLAG_GADGETMODE(_LITE) hat
    end if
  end if
end sub


sub ExtendedActionExecute
  dim as ExtendedAction ptr xaction
  xaction=ExtendedActionList->GetFirst
  if xaction then
    do
      if (GADGETMESSAGE<>0) and (GADGETMESSAGE=xaction->cause_gad) then xaction->DoExtendedAction(xaction)    
      xaction=cast(ExtendedAction ptr,xaction->next_node)
    loop until xaction=0
  end if
  xaction=ExtendedActionList->GetFirst
  if xaction then
    do   
      if (WINDOWMESSAGE<>0) and (WINDOWMESSAGE=xaction->cause_win) then xaction->DoExtendedAction(xaction)
      xaction=cast(ExtendedAction ptr,xaction->next_node)
    loop until xaction=0
  end if  
end sub


sub Update_Crawler
  dim as sGUIList ptr Lst
  dim as Gadget ptr Gad
  dim as sGUIWindow ptr Win
  Lst=GadgetLists->GetFirst
  if Lst then
    do
      Gad=Lst->GetFirst
      if Gad then
        do
          if Gad->Activation then UpdateGadget(Gad)
          Gad=cast(Gadget ptr,Gad->next_node)
        loop until Gad=0
      end if
      Lst=cast(sGUIList ptr,Lst->next_node)
    loop until Lst=0
  end if
  
  Lst=WindowLists->GetFirst
  if Lst then
    do
      Win=Lst->GetFirst
      if Win then
        do
          if Win->Activation then Win->DoUpdate(win)
          Win=cast(sGUIWindow ptr,Win->next_node)
        loop until Win=0
      end if
      Lst=cast(sGUIList ptr,Lst->next_node)
    loop until Lst=0
  end if 
end sub


sub Hover_Crawler(Win as sGUIWindow ptr)
  dim as sGUIList ptr Lst
  dim as Gadget ptr Gad
  dim as sGUIWindow ptr GadWin
  if Win then
    '1.) alle Gadgets "unhovern", mal nichts rekursives da alle Gadgets in double linked Listen sind :)
    Lst=GadgetLists->GetFirst
    if Lst then
      do
        Gad=Lst->GetFirst
        if Gad then
          do
            Gad->MouseHover=0
            Gad=cast(Gadget ptr,Gad->next_node)
          loop until Gad=0
        end if
        Lst=cast(sGUIList ptr,Lst->next_node)
      loop until Lst=0
    end if   
    Win->HoveringOverGadgetCheck
  end if
end sub


'******************************************************************************
'******************************************************************************
'******************************************************************************
'Message


sub AsParentWindowMessage_Crawler (Win as sGUIWindow ptr)
  if Win then
    WINDOWMESSAGE=Win'sieht beim Einstieg doof aus, da ja WINDOWMESSAGE als Parameter bergeben wurde... erst in der Rekursion ergibt es einen Sinn
    if (Win->WinFlags and WFLAG_PARENTSELECT) then AsParentWindowMessage_Crawler(cast(sGUIWindow ptr,Win->Parent))  
  end if
end sub


'******************************************************************************
'******************************************************************************
'******************************************************************************
'GUI GFX Build


sub DrawScreen
  DrawGadgets_Crawler   
  sGUIScreenSet 1,1
    screenlock
      screencopy 0,1
      GUIBuild_Crawler (RootWindow) 
    screenunlock
  sGUIScreenSet 0,1
end sub


sub DrawGadgets_Crawler
  dim as sGUIList ptr Lst
  dim as Gadget ptr Gad
  Lst=GadgetLists->GetFirst
  if Lst then
    do
      Gad=Lst->GetFirst
      if Gad then
        do
          if DrawRequest(Gad) then Gad->DoDraw (Gad)'DrawGadget(Gad)
          Gad=cast(Gadget ptr,Gad->next_node)
        loop until Gad=0
      end if
      Lst=cast(sGUIList ptr,Lst->next_node)
    loop until Lst=0
  end if 
end sub


sub GUIBuild_PutGadgetImage (Win as sGUIWindow ptr, ChildGad as Gadget ptr, ThisImage as FB.Image ptr)
  if ChildGad->Activation then
    'Ausnahme RootWindow: dieses hat selbst kein Image(ThisImage=0), darum werden hier die Child-Gadgets direkt in den Screen(Page 1) kopiert
    if ThisImage then
      put ThisImage,(Win->ContentOffsetX + ChildGad->PosX, Win->ContentOffsetY + ChildGad->PosY), ChildGad->DrawBuffer->img, trans'pset          
    else
      put (Win->ContentOffsetX + ChildGad->PosX, Win->ContentOffsetY + ChildGad->PosY), ChildGad->DrawBuffer->img, trans'pset          
    end if    
  end if
end sub


sub GUIBuild_Crawler(Win as sGUIWindow ptr)
  dim as Gadget ptr ChildGad,ParentGad
  dim as sGUIWindow ptr ChildWin,ParentWin
  dim as FB.Image ptr ParentImage,ThisImage
  dim as sGUIList ptr Lst
  
  'Imageadressen:
  if Win<>RootWindow then
    'Jedes normale Fenster hat ein ParentWindow
    'dessen Image wird ins Image des ParentWindows an entprechender Position hinein kopiert     
    ParentWin=cast(sGUIWindow ptr,Win->Parent)
    ParentImage=ParentWin->DrawBuffer->img
    ThisImage=Win->DrawBuffer->img
  else
    'Ein RootWindow hat weder ParentWindow noch eine eigenes Image
    'dessen Childobjekte, also Windows wie Gadgets, werden direkt auf den Screen(Page 1) kopiert
    ParentImage=0
    ThisImage=0
  end if
    
  'Fensteraufbau im fenstereigenen Image:
  '1. SchattenFX,"Saubermachen" und UserGFX hineinkopieren
  if Win<>RootWindow then
    if Win->Activation then 
      if ( Win->WinFlags and WFLAG_NOSHADOW)=0 then _
        WinShadow (ParentImage, ParentWin->ContentOffsetX + Win->PosX, ParentWin->ContentOffsetY + Win->PosY, Win->WinWidth, Win->WinHeight)             
      Win->DoClearWindow (Win)
    end if    
  end if
 
  '2. Child-Gagdets ins Fenster kopieren
  'Loop durch die GadgetList dieses Fensters 
  Lst=Win->GadgetList
  ChildGad=Lst->GetFirst  
  if ChildGad then
    do             
      GUIBuild_PutGadgetImage (Win,ChildGad,ThisImage)
      ChildGad=cast(Gadget ptr,ChildGad->next_node)
    loop until ChildGad=0
  end if   
  
  '3.ChildWindows erstellen (rekursiv), diese kopieren sich dann selbst nach "unten" ins Image seines Parents
  'Loop durch die WindowList dieses Fensters
  ChildWin=Win->WindowList->GetFirst
  if ChildWin then
    do
      GUIBuild_Crawler(ChildWin)
      ChildWin=cast(sGUIWindow ptr,ChildWin->next_node)
    loop until ChildWin=0
  end if
  
  '4. Rahmen ins Fenster zeichnen, soweit einer existieren soll
  Win->DoDrawWindow (Win)
  
  '5. fenstereigene Gadgets(es ist ne andere Gadgetliste als in 3. !) in Fenster kopieren (bisher nur Drag/Close)
  'Loop durch die WinGadgetList dieses Fensters 
  ChildGad=Win->WinGadgetList->GetFirst  
  if ChildGad then
    do             
      GUIBuild_PutGadgetImage (Win,ChildGad,ThisImage)
      ChildGad=cast(Gadget ptr,ChildGad->next_node)
    loop until ChildGad=0
  end if  
  
  '6. das nun fertige Fenster in sein Parent kopieren (betrifft Aussage in Step 3)
  'Ausnahme RootWindow: hier kopieren sich dessen Child-Windows direkt in den Screen(Page 1)
  if Win<>RootWindow then
    if Win->Activation then
      if ParentImage then
        put ParentWin->DrawBuffer->img,(ParentWin->ContentOffsetX + Win->PosX, ParentWin->ContentOffsetY + Win->PosY),Win->DrawBuffer->img,trans'pset'alpha 
      else
        put (ParentWin->ContentOffsetX + Win->PosX, ParentWin->ContentOffsetY + Win->PosY),Win->DrawBuffer->img,trans'pset'alpha      
      end if
    end if
  end if
  
end sub


'******************************************************************************
'******************************************************************************
'******************************************************************************
'Adressen


sub GetHoveredObjects(byref Win as sGUIWindow ptr, byref Gad as Gadget ptr)
  dim as ulong GMfilter
  dim as integer exitsignal
  GMfilter=WFLAG_GADGETMODE or WFLAG_GADGETMODE_LITE
  Win=0
  Gad=0
  exitsignal=0
  if (MOUSEOVERWINDOW->WinFlags and GMfilter) then
      Win=MOUSEOVERWINDOW
      do   
        if (cast(sGUIWindow ptr, Win->Parent)->Winflags and GMfilter) then
          Win=Win->Parent
        else
          exitsignal=1
        end if
      loop until exitsignal
      Gad=cast(any ptr,Win) 
  else
    Win=MOUSEOVERWINDOW
    Gad=MOUSEOVERGADGET
  end if 
end sub


function IsChildOf(parentwin as sGUIWindow ptr, child as any ptr) as integer
  dim as sGUIWindow ptr wingad
  dim as integer result
  function=0
  result=0
  if (child<>0) andalso (child<>RootWindow) then
    wingad=child
    do      
      wingad=wingad->Parent
      if wingad=parentwin then result=1
    loop until (result>0) or (wingad=RootWindow)
    function=result
  end if
end function


function GetWindowPointer(Win as sGUIWindow ptr=RootWindow, wwi as integer=WARNWARNIGNORE) as sGUIWindow ptr
  dim as _sGUIWindow ptr ChildWin,hoverwin,tmp
  dim as integer WinX,WinY
  GetGlobalPosition(Win,WinX,WinY)    
  if wwi then
    hoverwin=0
    'nur WARN/WARNIGNORE und dessen Childs abfragen
    ChildWin=RootWindow->WindowList->GetFirst
    if ChildWin then
      do
        if (ChildWin->WinFlags and WFLAG_WARN) or (ChildWin->WinFlags and WFLAG_WARNIGNORE) then
          if ChildWin->Activation then'nur bei Activation=1 gibt es eine Antwort        
            if (MOUSEX >= WinX+ChildWin->PosX) and (MOUSEX < WinX+ChildWin->PosX+ChildWin->WinWidth) and _
               (MOUSEY >= WinY+ChildWin->PosY) and (MOUSEY < WinY+ChildWin->PosY+ChildWin->WinHeight) then
               hoverwin=ChildWin        
            end if
          end if
        end if        
        ChildWin=cast(sGUIWindow ptr,ChildWin->next_node)
      loop until ChildWin=0
    end if
    if hoverwin>0 then hoverwin=GetWindowPointer(hoverwin,0)'rekursiver Aufruf ohne wwi  
  
  else  
  
  hoverwin=Win
  ChildWin=Win->WindowList->GetFirst
    if ChildWin then
      do
        if ChildWin->Activation then'nur bei Activation=1 gibt es eine Antwort        
          if (MOUSEX >= WinX+ChildWin->PosX) and (MOUSEX < WinX+ChildWin->PosX+ChildWin->WinWidth) and _
             (MOUSEY >= WinY+ChildWin->PosY) and (MOUSEY < WinY+ChildWin->PosY+ChildWin->WinHeight) then
             hoverwin=ChildWin        
          end if
        end if  
        ChildWin=cast(sGUIWindow ptr,ChildWin->next_node)
      loop until ChildWin=0
    end if
    if hoverwin<>Win then hoverwin=GetWindowPointer(hoverwin,0)'rekursiver Aufruf ohne warn/warnignore    
  end if 
  function=hoverwin
end function


sub WarnWarnIgnoreCheck
  dim as sGUIWindow ptr Win
  WARNWARNIGNORE=0
  Win=RootWindow->WindowList->GetFirst
  if Win then
    do
      if Win->Activation then
        if (Win->WinFlags and WFLAG_WARN) or (Win->WinFlags and WFLAG_WARNIGNORE) then WARNWARNIGNORE=1
      end if  
      Win=cast(sGUIWindow ptr,Win->next_node)
    loop until (Win=0) or (WARNWARNIGNORE=1)
  end if
end sub


function GetDropDownWindow as sGUIWindow ptr
  dim as sGUIList ptr Lst
  dim as sGUIWindow ptr Win,DropDownWin
  DropDownWin=0
  Lst=WindowLists->GetFirst
  if Lst then
    do
      Win=Lst->GetFirst
      if Win then
        do
          if Win->Activation then
            if (Win->WinFlags and WFLAG_WARNIGNORE) then 
              if DropDownWin then
                if Win->ActiveSince >= DropDownWin->ActiveSince then DropDownWin=Win
              else
                DropDownWin=Win
              end if
            end if
          end if
          Win=cast(sGUIWindow ptr,Win->next_node)
        loop until (Win=0)
      end if
      Lst=cast(sGUIList ptr,Lst->next_node)
    loop until (Lst=0)
  end if  
  function=DropDownWin
end function

