#include "sGUI\sGUI.bas"
#include once "sGUI\Gadget_ScrollBar.bas"
#include once "sGUI\Gadget_DropDownListBox.bas"
#include once "sGUI\Gadget_Label.bas"
#include once "sGUI\Gadget_SimpleToggle.bas"
#include once "sGUI\Gadget_RadioCheck.bas"
#include once "sGUI\Gadget_TextField.bas"
#include once "sGUI\Gadget_String.bas"
#include once "sGUI\Gadget_FileRequester.bas"
#include once "sGUI\Gadget_Menu.bas"
using sGUI

declare sub SetSliders(entry as integer)
declare sub SetColor (entry as integer) 
declare sub DrawGadgets

sGUIScreenRes 1280,800,32

InitGUI
color Colors.Pen,Colors.BackGround
cls
windowtitle "Beautifier...  a very basic color scheme editor"
LoadProportionalFont("Fonts\Ubuntu-Regular_10\Ubuntu-Regular_10.bmp")
LoadFixedFont("Fonts\Ubuntu-Regular-Mono\Ubuntu-Regular-Mono.bmp")
LoadMenuFont("Fonts\Ubuntu-Regular_10\Ubuntu-Regular_10.bmp")

'ToolBox***********************************************************************
dim as sGUIWindow ptr ToolBox
'die Gadgets der Toolbox sind shared, damit die Subs SetSliders() und SetColor() auf einfachem Weg darauf zugreifen knnen
'nicht die hohe Kunst, was solls... ;)
dim shared as Gadget ptr fr,ddlColors, scrRed, scrGreen, scrBlue, scrBvl, scrGrd, scrFrame, lblRGB, lblBvl, lblGrd, lblFrame, chkhover,chkFrame, savesnippet
fr=AddFileRequester("Speichern","Abbruch")

ToolBox=AddWindow(0,430,50,340,500,"ColorSchemeToolBox",WFLAG_FRAMED or WFLAG_TITLEBAR or WFLAG_DRAGABLE or WFLAG_CLOSEABLE)

ddlColors=AddDropDownListBox(ToolBox,10,10,320,25,400,150)
#include "Beautifierincludes\AddEntries.bas"

SetDDListBox(ddlColors,2)'Background vorselekieren  
lblRGB=AddLabel (ToolBox,10,40,"R,G,B (hex): ")
scrRed=AddScrollBar(ToolBox,10,70,320,0,255,1,1,0)
scrGreen=AddScrollBar(ToolBox,10,100,320,0,255,1,1,0)
scrBlue=AddScrollBar(ToolBox,10,130,320,0,255,1,1,0)
chkFrame=AddCheckMarkGadget (ToolBox,10,170,"Frame FX")
lblFrame=AddLabel (ToolBox,10,200,"FrameContrastFX: " & FrameContrastFX)
scrFrame=AddScrollBar(ToolBox,10,230,320,-100,100,1,1,0)
lblBvl=AddLabel (ToolBox,10,270,"BevelFX: " & BevelFX)
scrBvl=AddScrollBar(ToolBox,10,300,320,0,100,1,1,0)
lblGrd=AddLabel (ToolBox,10,340,"GradientFX: " & GradientFX)
scrGrd=AddScrollBar(ToolBox,10,370,320,0,100,1,1,0)
chkhover=AddCheckMarkGadget (ToolBox,10,410,"Hover FX")
savesnippet=AddSimpleGadget(ToolBox,10,460,320,30,"save colors as code snippet")

if HoverFX then SetSelect(chkhover)
if FrameFX then SetSelect(chkFrame)

GadgetOn(ddlColors)
GadgetOn(scrRed)
GadgetOn(scrGreen)
GadgetOn(scrBlue)
GadgetOn(scrFrame)
GadgetOn(lblRGB)
GadgetOn(lblGrd)
GadgetOn(scrGrd)
GadgetOn(chkFrame)
if FrameFX then
  GadgetOn(lblBvl)
  GadgetOn(scrBvl)  
  GadgetOn(lblFrame)
  GadgetOn(scrFrame)        
else
  GadgetSleep(lblBvl)
  GadgetSleep(scrBvl)  
  GadgetSleep(lblFrame)
  GadgetSleep(scrFrame)        
end if
GadgetOn(chkhover)
GadgetOn(savesnippet)

'Demoobjekte*******************************************************************

dim as sGUIWindow ptr win1
dim as Gadget ptr btn,tgl,ddl,lst,edb,tfld,btnsleep
dim as Gadget ptr rdo1,rdo2,rdo3,chk1,chk2,chk3,openWinbtn,lblinfo
btn=AddSimpleGadget(0,10,10,,,"Button")

tgl=AddToggleGadget(0,130,10,80,120,"Toggle")
SetSelect(tgl)
ddl=AddDropDownListBox(0,10,140,150,30,280,100,1)'mit rotierender Liste
for i as integer=1 to 10   
  AddEntry(ddl,"Entry " & i )
next i
SetDDListBox(ddl,4)
SetEntryActivation(ddl,2,0)
SetEntryActivation(ddl,3,0)

btnsleep=AddSimpleGadget(0,180,140,,,"Sleep Button")
edb=AddTextField (0,10,200,400,150)
edb->xtd.TContainer->LoadText "X_00_Beautifier.bas"
tfld=AddStringGadget (0,10,360,300)

lst=AddListBox(0,10,500,350,90,2,2)' MultiSelect/DirectoryMode
'ein Fake-Verzeichnis erzeugen
AddEntry(lst,"Directory X",ETYPE_DIR)
AddEntry(lst,"Directory Y",ETYPE_DIR)
AddEntry(lst,"File A",ETYPE_FILE)
AddEntry(lst,"File Z",ETYPE_FILE)

rdo1=AddRadioButton (0,240,10,"Radio 1",0)
rdo2=AddRadioButton (0,240,50,"Radio 2",rdo1)
rdo3=AddRadioButton (0,240,90,"Radio 3",rdo1,1)
chk1=AddCheckMarkGadget (0,400,10,"Check 1")
chk2=AddCheckMarkGadget (0,400,50,"Check 2")
chk3=AddCheckMarkGadget (0,400,90,"Check 3",1)
openWinbtn=AddSimpleGadget (0,560,10,230,25,"Show ToolBox")

lblinfo=AddLabel (0,330,140,"!!! Hit right mouse button for a sample popupmenu !!!")

win1=AddWindow(0,10,420,350,30,"unselected Window (WFLAG_NOSHADOW)",WFLAG_FRAMED or WFLAG_TITLEBAR or WFLAG_DRAGABLE or _
                WFLAG_STACKABLE or WFLAG_APPEARSUNSELECTED or WFLAG_NOSHADOW)
ShowWindow(win1)

GadgetOn(btn)
GadgetOn(tgl)
GadgetOn(ddl)
GadgetOn(lst)
GadgetOn(edb)
GadgetOn(tfld)
GadgetSleep(btnsleep)
GadgetOn(rdo1)
GadgetOn(rdo2)
GadgetOn(rdo3)
GadgetOn(chk1)
GadgetOn(chk2)
GadgetOn(chk3)
GadgetOn(openWinbtn)
GadgetOn(lblinfo)

SetLabelColor(lblRGB,Colors.Pen)
SetLabelColor(lblBvl,Colors.Pen )
SetLabelColor(lblGrd,Colors.Pen )
SetLabelColor(lblFrame,Colors.Pen )
SetLabelColor(lblinfo,Colors.Pen )

ShowWindow(ToolBox)

dim as sGUIList ptr menulist=NewMenuBase
Item(menulist,"Item",1)
Item(menulist,"inactive Item",0)
OpenMenuStrip (menulist,"SubMenu...")
  Item(menulist,"Item",1)
  Item(menulist,"Item",1)
   OpenMenuStrip (menulist,"SubSub...")
    Item(menulist,"Item",1)
    Item(menulist,"Item",1)  
  CloseMenuStrip(menulist) 
CloseMenuStrip(menulist) 
Separator(menulist)
RadioButton(menulist,"Radio",,1,0)'ID=12
RadioButton(menulist,"Button",,0,12)
RadioButton(menulist,"Group",,0,12)
Separator(menulist)
CheckMark(menulist,"CheckMark",,0)
CreatePopUpMenu(menulist)

'******************************************************************************
dim as single rad=0
dim as string filename

'DDBox u. Slider der ToolBox auf Gagdet Body
SetDDListBox(ddlColors,7)
SetSliders(7)
do
  sleep 1
  MasterControlProgram '0=gfx am Ende via DrawScreen

  if RMB=RELEASE then OpenPopUpMenu(menulist,MOUSEX, MOUSEY)    
  
  if GADGETMESSAGE then
   
    select case GADGETMESSAGE
      case ddlColors
        SetSliders(GetDDListBox(ddlColors))
        DrawGadgets'siehe unten
        
      case scrRed,scrGreen,scrBlue
        SetColor(GetDDListBox(ddlColors))
        SetLabelColor(lblRGB,Colors.Pen )
        SetLabelColor(lblBvl,Colors.Pen )         
        SetLabelColor(lblGrd,Colors.Pen )
        SetLabelColor(lblinfo,Colors.Pen )
        DrawGadgets'siehe unten
        
      case chkhover
        HoverFX=iif(GetSelect(chkhover)=1,1,0)
        
        'normalerweise sollte das Highlight Handling nicht whrend der Laufzeit aus und eingeschaltet werden!
        'Da wir dies hier nun aber tun, und die CheckBox ist beim Abschalten highlighted, kommt es in ihr zu einem Grafikfehler.      
        'darum dieser kleine Hack hier:
        if GetSelect(chkhover)=0 then chkhover->MouseHover=0
        DrawGadgets'siehe unten

      case chkFrame
        FrameFX=iif(GetSelect(chkFrame)=1,1,0)
        if FrameFX then
          GadgetOn(lblBvl)
          GadgetOn(lblFrame)
          GadgetOn(scrBvl)
          GadgetOn(scrFrame)        
        else
          GadgetSleep(lblBvl)
          GadgetSleep(lblFrame)
          GadgetSleep(scrBvl)
          GadgetSleep(scrFrame)        
        end if       
        DrawGadgets'siehe unten        
                
      case scrBvl
        BevelFX=GetScrollBar(scrBvl)
        SetLabelText(lblBvl, "BevelFX: " & BevelFX)
        DrawGadgets'siehe unten
        
      case scrGrd
        GradientFX=GetScrollBar(scrGrd)
        SetLabelText(lblGrd, "GradientFX: " & GradientFX)
        DrawGadgets'siehe unten
      
      case scrFrame
        FrameContrastFX=GetScrollBar(scrFrame)
        SetLabelText(lblFrame, "FrameContrastFX: " & FrameContrastFX)
        DrawGadgets'siehe unten         
        
      case savesnippet       
        #include "Beautifierincludes\SaveSnippet.bas"       
        
      case openWinbtn
        ShowWindow(ToolBox)
        ShowWindow(win1)
    end select
  end if
  'DrawScreen
  
loop until SCREENCLOSEBUTTON


sub SetSliders(entry as integer)
  dim as ulong col

  #include "Beautifierincludes\SetSliders.bas"  
 
  SetScrollBar (scrRed,(col and &HFF0000) shr 16)
  SetScrollBar (scrGreen,(col and &HFF00) shr 8)
  SetScrollBar (scrBlue,(col and &HFF))
  SetScrollBar (scrBvl,BevelFX)
  SetScrollBar (scrGrd,GradientFX)
  SetScrollBar (scrFrame,FrameContrastFX)  
  SetLabelText(lblRGB, "R,G,B (hex): "  & right("000000" & hex(col),6) )
  SetLabelText(lblBvl, "BevelFX: " & BevelFX)
  SetLabelText(lblGrd, "GradientFX: " & GradientFX)
  SetLabelText(lblFrame, "FrameContrastFX: " & FrameContrastFX)  
end sub


sub SetColor (entry as integer)
  dim as ulong col=(GetScrollBar(scrRed) shl 16) or (GetScrollBar(scrGreen) shl 8) or GetScrollBar(scrBlue) 
  SetLabelColor(lblRGB,Colors.Pen)
  SetLabelColor(lblBvl,Colors.Pen )
  SetLabelColor(lblGrd,Colors.Pen )
  SetLabelColor(lblFrame,Colors.Pen )
  SetLabelText(lblRGB, "R,G,B (hex): " & right("000000" & hex(col),6) )  
  
  #include "Beautifierincludes\SetColor.bas"  
  
  color Colors.Pen,Colors.BackGround
  cls  
end sub


'um die Prozessorlast zu verringern werden Gadgets nicht permanent, sondern nur bei Vernderungen neu gezeichnet.
'Das Verndern der RGB Werte der Pens gehrt nicht zu den Ereignissen, die ein Neuzeichnen auslsen,
'da die "sGUI-Palette" normalerweise fest definiert ist... und naja und genau darum... 
'erzwingen wir ausnahmsweise das Neuzeichnen der Gadgets mit Hilfe von Brechstange und dieser kleinen SUB hier.
'Dadurch steigt die Prozessorlast natrlich wieder und es kann bei etwas schmalbrstig ausgestatteten Rechnern
'zu Verzgerungseffekten kommen:
sub DrawGadgets
  dim as sGUIList ptr lst
  dim as Gadget ptr gad
  DrawRBMask(RadioButtonMask->img,sGUIMainSize, int(sGUIMainSize /2) )

  lst=GadgetLists->GetFirst
  if lst then
    do
      gad=lst->GetFirst
      if gad then
        do
          gad->DoDraw (gad)'DrawGadget(gad)
          gad=cast(Gadget ptr,gad->next_node)
        loop until gad=0
      end if
      lst=cast(sGUIList ptr,lst->next_node)
    loop until lst=0
  end if 
end sub

