namespace sGUI

declare function AddDragBar(win as sGUIWindow ptr=0,PosX as integer=0,PosY as integer=0,GadWidth as integer=0) as Gadget ptr
declare function DRG_Actions(gad as Gadget ptr,action as integer) as integer
declare sub DRG_Draw (gad as Gadget ptr)
declare sub DRG_Update (gad as _Gadget ptr)
/'
'DragBar Symbol_Xhair
type DRG_Data
	HitMouseX       as integer
	HitMouseY       as integer 
  ScrPosX         as integer
  ScrPosY         as integer
  oldWinSelection as integer
end type
'/
function AddDragBar(win as sGUIWindow ptr=0,PosX as integer=0,PosY as integer=0,GadWidth as integer=0) as Gadget ptr
  function=0  
  dim as Gadget ptr gad
  if win=0 then win=RootWindow
  gad=win->WinGadgetList->AppendNew (GadgetType)
  if gad then
    gad->parent=win
    gad->Selection=0
    gad->Activation=0
    gad->PosX=PosX
    gad->PosY=PosY
    gad->GadHeight=GetFontHeight + 2*sGUIMainGap
    gad->GadWidth=GadWidth
    'kein Image
    'gad->DrawBuffer->img=imagecreate(gad->GadWidth,Gad->GadHeight,Colors.Cleaning,32)
    'gad->DoDraw     =@DRG_Draw'bentigen wir wohl nicht mehr
    gad->DoAction   =@DRG_Actions
    gad->DoUpdate  =@DRG_Update
    gad->DeviceFlags=DFLAG_LMB      
    function=gad
  end if
end function


function DRG_Actions(gad as Gadget ptr,action as integer) as integer
  function=0
  dim as sGUIWindow ptr win,parentwin
  win=cast(sGUIWindow ptr, gad->parent)
  parentwin=cast(sGUIWindow ptr, win->parent)
  select case action     
    case GADGET_LMBHIT
      if win<>RootWindow then
        gad->xtd.drg.HitMouseX=MOUSEX - win->PosX
        gad->xtd.drg.HitMouseY=MOUSEY - win->PosY
        function=1
      end if
      
    case GADGET_LMBHOLD,GADGET_LMBHOLDOFF       
      'if win<>RootWindow then
        'folgende Zeilen positionieren das Fenster
        'aber ohne Limiter kann das Fenster vom User komplett aus dem
        'Contentbereich seines Parent verschoben werden und ist nicht mehr erreichbar! 
        win->PosX =MOUSEX - gad->xtd.drg.HitMouseX
        win->PosY =MOUSEY - gad->xtd.drg.HitMouseY

        'Limiter
        'es bleibt immer ein greifbarer Teil der Titelzeile des Fensters sichbar
        if win->PosX < -(win->WinWidth-30) then win->PosX= -(win->WinWidth-30)
        if win->PosX > (parentwin->ContentWidth -30) then win->PosX= (parentwin->ContentWidth -30)
        if win->PosY < 0 then win->PosY= 0
        if win->PosY > (parentwin->ContentHeight -30) then win->PosY= (parentwin->ContentHeight -30)
      'else
      '  SCREENMOVE=1
      'end if
      function=1
  end select  
end function

/'
sub DRG_Draw (gad as Gadget ptr)
	dim as integer GadWidth,GadHeight,TextPosX,TextPosY,WinSelection
	dim as FB.Image ptr Buffer
  dim as sGUIWindow ptr parentwin=cast(sGUIWindow ptr,gad->parent)	
	GadWidth =gad->GadWidth
	GadHeight=gad->GadHeight
	TextPosX =int((GadWidth-GetTextWidth(parentwin->Text))/2)
	TextPosY =int((GadHeight-GetFontHeight)/2)
	Buffer   =gad->DrawBuffer->img
  
  WinSelection=parentwin->Selection
  'WinFlag Override
  if (parentwin->WinFlags and WFLAG_APPEARSSELECTED) then WinSelection=1
  if (parentwin->WinFlags and WFLAG_APPEARSUNSELECTED) then WinSelection=0
'OFF 
  ClearBox Buffer,0,0,GadWidth,GadHeight
'ON   unselect/select
  if gad->Activation then
    if WinSelection then
      FrameTypeA Buffer,0,0,GadWidth,GadHeight,Colors.WinFrame,,0,0        
		else
      FrameTypeA Buffer,0,0,GadWidth,GadHeight,Colors.WinFrameUnselected,,0,0	      
    end if	
'SLEEP
    'keine Sleep gfx
  end if
end sub
'/

sub DRG_Update (gad as _Gadget ptr)
  if gad->xtd.drg.oldWinSelection <> cast(sGUIWindow ptr,gad->parent)->Selection  then	
    gad->ReDraw=1
    gad->xtd.drg.oldWinSelection = cast(sGUIWindow ptr,gad->parent)->Selection
  end if
end sub

end namespace
