#include once "Gadget_ParentBtn.bas"
#include once "Gadget_SimpleToggle.bas"
#include once "Gadget_Label.bas"
#include once "Gadget_String.bas"
#include once "Gadget_ListBox.bas"

namespace sGUI

declare function AddFileRequester (doit as string="doit", cancel as string="cancel", Mode as integer=0) as any ptr
declare sub FRQ_ExtendedAction (xaction as ExtendedAction ptr)
declare sub FRQ_Actions (win as sGUIWindow ptr)

declare sub ShowFileRequester (thing as any ptr,Path as string="",Filename as string="")
declare function GetFileRequester (thing as any ptr) as string
declare function OpenFileRequester(thing as any ptr,Path as string=curdir,File as string="") as string

function AddFileRequester (doit as string="doit", cancel as string="cancel", Mode as integer=0) as any ptr
  function=0  
  dim as sGUIWindow ptr gwin
  dim as sGUIWindow ptr wwin
  dim as ExtendedAction ptr xaction
  dim as integer heightrun
  'Gesamthhe Fenster
  heightrun= 5*10' 2xSpace to Window Border top/bottom, 3xSpace between Gadgets
  heightrun += 2*GetFontHeight(1) + 4*sGUIMainGap' 2xStringGadget
  heightrun += 285'ListBox
  heightrun += GetFontHeight+2*sGUIMainGap'Button Row

  gwin=AddWindow(0,20,20,400,heightrun,doit,WFLAG_FRAMED or WFLAG_TITLEBAR or WFLAG_DRAGABLE or WFLAG_CLOSEABLE or WFLAG_WARN or WFLAG_GADGETMODE_LITE)  
  if gwin then
    gwin->Activation=0  
     
    'Windows Variante
    #ifdef __fb_win32__
      gwin->xtd.frq.Separator=asc("\")
    #endif
    'Tux Variante
    #ifdef __FB_LINUX__
      gwin->xtd.frq.Separator=asc("/")
    #endif       
    
    heightrun=10
    gwin->xtd.frq.btn_parent=AddParentBtn(gwin,10,heightrun,25,GetFontHeight(1) + 2*sGUIMainGap)      
    gwin->xtd.frq.stg_path=AddStringGadget(gwin,40,heightrun,350,,,1)'nach Return wird Stringende angezeigt
    
    heightrun += 10 + GetFontHeight(1) + 2*sGUIMainGap
    gwin->xtd.frq.lbx_content=AddListBox(gwin,10,heightrun,380,285,2)'DisplayMode 2= Directory Darstellung      
      wwin=AddSimpleWarnWindow(0,0,"Path and/or file not valid")
    
    heightrun += 10 + 285
    gwin->xtd.frq.lbl_file=AddLabel(gwin,10,heightrun,"File:")      
    gwin->xtd.frq.stg_file=AddStringGadget(gwin,60,heightrun,330)      
    
    heightrun += 10 + GetFontHeight(1) + 2*sGUIMainGap   
    gwin->xtd.frq.btn_doit=AddSimpleGadget(gwin,130,heightrun,125,0,doit)
    gwin->xtd.frq.btn_cancel=AddSimpleGadget(gwin,265,heightrun,125,0,cancel)
       
    gwin->xtd.frq.Mode=Mode
    gwin->xtd.frq.frqWarnWindow=wwin      
    gwin->DoAction   =@FRQ_Actions

    SetString(gwin->xtd.frq.stg_path,curdir)
    DirToListBox gwin->xtd.frq.lbx_content, GetString(gwin->xtd.frq.stg_path)
    
    xaction=ExtendedActionList->AppendNew (ExtendedActionType)
    if xaction then
      xaction->cause_win				=gwin				
      xaction->DoExtendedAction	=@FRQ_ExtendedAction
      xaction->effect_gad			  =cast(any ptr,gwin)
    end if

    GadgetOn(gwin->xtd.frq.btn_parent) 
    GadgetOn(gwin->xtd.frq.stg_path)  
    GadgetOn(gwin->xtd.frq.lbx_content) 
    GadgetOn(gwin->xtd.frq.lbl_file)
    GadgetOn(gwin->xtd.frq.stg_file)
    GadgetOn(gwin->xtd.frq.btn_doit)    
    GadgetOn(gwin->xtd.frq.btn_cancel)    
    function=gwin
  end if

end function


sub FRQ_ExtendedAction (xaction as ExtendedAction ptr)
  dim as sGUIWindow ptr win
  dim as Gadget ptr gad
	win=xaction->cause_win
	gad=xaction->effect_gad
  if win->Activation=0 then GADGETMESSAGE=gad
end sub


sub FRQ_Actions(win as sGUIWindow ptr)
  dim as string full
  dim as integer ox,oy,result
  result=0
  
  if GADGETMESSAGE then      
    
    select case GADGETMESSAGE
      case win->xtd.frq.btn_parent
        chdir ".."   
        SetString(win->xtd.frq.stg_path,curdir)
        DirToListBox win->xtd.frq.lbx_content, GetString(win->xtd.frq.stg_path)        
    
      case win->xtd.frq.stg_path
        chdir GetString(win->xtd.frq.stg_path)   
        SetString(win->xtd.frq.stg_path,curdir)
        DirToListBox win->xtd.frq.lbx_content, GetString(win->xtd.frq.stg_path)         

      case win->xtd.frq.lbx_content
        if GetListBox(win->xtd.frq.lbx_content) then
          if GetEntryType( win->xtd.frq.lbx_content, GetListBox(win->xtd.frq.lbx_content) )=ETYPE_DIR then
            chdir GetEntryText(win->xtd.frq.lbx_content,GetListBox(win->xtd.frq.lbx_content))
            SetString(win->xtd.frq.stg_path,curdir)
            DirToListBox win->xtd.frq.lbx_content,GetString(win->xtd.frq.stg_path)
          else
            SetString(win->xtd.frq.stg_file,GetEntryText(win->xtd.frq.lbx_content,GetListBox(win->xtd.frq.lbx_content)))  
          end if
        end if
    
      case win->xtd.frq.btn_doit, win->xtd.frq.stg_file
        if right(GetString(win->xtd.frq.stg_path),1)<> chr(win->xtd.frq.Separator) then
          full= GetString(win->xtd.frq.stg_path) & chr(win->xtd.frq.Separator) & GetString(win->xtd.frq.stg_file)
        else
          full= GetString(win->xtd.frq.stg_path) & GetString(win->xtd.frq.stg_file)
        end if
        
        
        if win->xtd.frq.Mode then
          if fileexists(full) then
            win->xtd.frq.RequestSuccess=1
            HideWindow(win)            
            result=1
          
          else
            'WarnFenster mittig zum FR ausrichten und anzeigen
            ox=(win->WinWidth - win->xtd.frq.frqWarnWindow->WinWidth) /2
            oy=(win->WinHeight - win->xtd.frq.frqWarnWindow->WinHeight) /2
            win->xtd.frq.frqWarnWindow->PosX = win->PosX + ox
            win->xtd.frq.frqWarnWindow->PosY = win->PosY + oy
            ShowWindow (win->xtd.frq.frqWarnWindow)
          end if  
        
        else            
          win->xtd.frq.RequestSuccess=1
          HideWindow(win)            
          result=1               
        
        end if

      case win->xtd.frq.btn_cancel
        win->xtd.frq.RequestSuccess=0          
        HideWindow(win)
        result=1
      
     end select
  end if 
  GADGETMESSAGE=0
  
  if result then GADGETMESSAGE=cast(any ptr,win) 
end sub


sub ShowFileRequester (thing as any ptr, Path as string="", Filename as string="")
  dim as sGUIWindow ptr win
  win=cast(sGUIWindow ptr,thing)  
  if Path<>"" then chdir Path 
  SetString(win->xtd.frq.stg_path,curdir)
  DirToListBox win->xtd.frq.lbx_content, GetString(win->xtd.frq.stg_path)

  if Filename<>"" then SetString(win->xtd.frq.stg_file,Filename) 
  win->xtd.frq.RequestSuccess=0
  ShowWindow(win)
end sub


function GetFileRequester (thing as any ptr) as string
  dim as sGUIWindow ptr win
  dim as string full
  win=cast(sGUIWindow ptr,thing)
  full=""
  if win->xtd.frq.RequestSuccess=1 then 
    
    if right(GetString(win->xtd.frq.stg_path),1)<> chr(win->xtd.frq.Separator) then
      full= GetString(win->xtd.frq.stg_path) & chr(win->xtd.frq.Separator) & GetString(win->xtd.frq.stg_file)
    else
      full= GetString(win->xtd.frq.stg_path) & GetString(win->xtd.frq.stg_file)
    end if  
   
  else
    full=""
  end if
  
  function=full
end function


function OpenFileRequester(thing as any ptr,Path as string=curdir,Filename as string="") as string
  function=""
  dim as integer screencfg, exitloop
  screencfg=sGUIScreenSet'vorherigen Screenzustand speichern
  exitloop=0
  ShowFileRequester (thing,Path,Filename)  
  do
    sleep 1
    MasterControlProgram
    if GADGETMESSAGE then
      select case GADGETMESSAGE
        case thing
          function=GetFileRequester(thing)
          exitloop=1
      end select
    end if
    'das Fenster des FR-Gadgets hat einen CloseButton
    'hierber wird dessen Activation-Status berprft.
    'Sollte dieser 0 sein, wurde der CloseButton gedrckt
    'Dann !!!MUSS!!! dieser Loop auch verlassen werden:
    if cast(sGUIWindow ptr,thing)->Activation=0 then exitloop=1
  loop until exitloop
  sGUIScreenSet( (screencfg shr 4), (screencfg and &HF) )'alten Screenzustand wiederherstellen
end function

end namespace
