namespace sGUI

declare function AddLabel (win as sGUIWindow ptr,PosX as integer,PosY as integer,Text as string,TextColor as ulong=Colors.Pen) as Gadget ptr
declare function LBL_Actions(gad as Gadget ptr,action as integer) as integer
declare sub LBL_Draw (gad as Gadget ptr)

declare sub SetLabelText (gad as Gadget ptr,Text as string)
declare sub SetLabelColor (gad as Gadget ptr,LabelColor as ulong)
/'
type LBL_Data
	TextColor as ulong
end type
'/
function AddLabel (win as sGUIWindow ptr,PosX as integer,PosY as integer,Text as string,LabelColor as ulong=Colors.Pen) as Gadget ptr
	function=0  
	dim as Gadget ptr gad
	if win=0 then win=RootWindow
	gad=win->GadgetList->AppendNew (GadgetType)
	if gad then
		gad->parent=win
		gad->Selection=0
		gad->Activation=0
		gad->PosX=PosX
		gad->PosY=PosY
    gad->GadWidth=GetTextWidth(Text)
    gad->GadHeight=GetFontHeight
    gad->Text=Text
    
		gad->xtd.lbl.TextColor=LabelColor
		
		gad->DrawBuffer->img=imagecreate(gad->GadWidth,Gad->GadHeight)    
		gad->DoDraw     =@LBL_Draw
    gad->DoAction   =@LBL_Actions
    'gad->DoUpdate=@FakeUpdate' zu finden im Constructor des Gadgettypes in sGUI_WindowGadgetType.bas
    gad->DeviceFlags=DFLAG_LMB
    function=gad
  end if

end function


function LBL_Actions(gad as Gadget ptr,action as integer) as integer
  function=0
  select case action
    case GADGET_LMBRELEASE
      function=1
  end select
end function


sub LBL_Draw (gad as Gadget ptr)
	dim as integer GadWidth,GadHeight
  dim as ulong bcol
  dim as FB.Image ptr Buffer
	GadWidth =gad->GadWidth
	GadHeight=gad->GadHeight
  Buffer   =gad->DrawBuffer->img
	if cast(sGUIWindow ptr,gad->parent)=RootWindow then bcol=Colors.BackGround else bcol=Colors.BackGround
'OFF 
  ClearBox Buffer,0,0,GadWidth,GadHeight,bcol
'ON   unselect/select
	drawstring (Buffer,0,0, gad->Text,gad->xtd.lbl.TextColor)
'SLEEP
	if gad->Activation=2 then Raster Buffer,0,0,GadWidth,GadHeight
end sub


sub SetLabelText (gad as Gadget ptr,Text as string)
	dim as FB.Image ptr imgtmp
	gad->GadWidth=GetTextWidth(Text)
	gad->GadHeight=GetFontHeight
	gad->Text=Text
	'der Umweg ber imgtmp ist ein workaround um ein Bug aus alten Zeiten. Ich wei nicht einmal, ob er inzwischen gefixt ist
	'es ging um die direkte "Wiederverwendung" eines Image Pointers durch IMAGECREATE nach einem IMAGEDESTROY...
	'in einer lteren Compilerversion ging das iwie nicht.
	if gad->DrawBuffer->img then imagedestroy gad->DrawBuffer->img
  imgtmp=imagecreate(gad->GadWidth,gad->GadHeight)
	if imgtmp then gad->DrawBuffer->img=imgtmp
  gad->ReDraw=1
end sub


sub SetLabelColor (gad as Gadget ptr,LabelColor as ulong)
  gad->xtd.lbl.TextColor=LabelColor
  gad->ReDraw=1
end sub
	
end namespace
