namespace sGUI

declare function AddButton(win as sGUIWindow ptr,PosX as integer,PosY as integer) as Gadget ptr
declare function Button_Actions(gad as Gadget ptr,action as integer) as integer
declare sub Button_Update(gad as Gadget ptr)
declare sub Button_Draw (gad as Gadget ptr)

declare function AddString(win as sGUIWindow ptr,PosX as integer,PosY as integer) as Gadget ptr
declare function String_Actions(gad as Gadget ptr,action as integer) as integer
declare sub String_Update(gad as Gadget ptr)
declare sub String_Draw (gad as Gadget ptr)

'******************************************************************************
'******************************************************************************
'******************************************************************************

function AddButton(win as sGUIWindow ptr,PosX as integer,PosY as integer) as Gadget ptr
	function=0  
	dim as Gadget ptr gad
	if win=0 then win=RootWindow
	gad=win->GadgetList->AppendNew (GadgetType)
	if gad then
		gad->parent=win
		gad->Selection=0
		gad->Activation=0
		gad->PosX=PosX
		gad->PosY=PosY
		gad->GadWidth=30
		gad->GadHeight=30 
    gad->DrawBuffer->img=imagecreate(gad->GadWidth,Gad->GadHeight)
		gad->DoDraw     =@Button_Draw
		gad->DoAction   =@Button_Actions
    gad->DoUpdate   =@Button_Update
		function=gad
	end if
end function



function Button_Actions(gad as Gadget ptr,action as integer) as integer
  function=0
  dim as string pre="Button"  
  
  select case action
'entweder direkte Mausaktion...
  
    case GADGET_LMBHIT 
      print pre & "(" & gad & "):GADGET_LMBHIT"
      
    case GADGET_LMBHOLD 
      print pre & "(" & gad & "):GADGET_LMBHOLD"    
    
    case GADGET_LMBHOLDOFF 
      print pre & "(" & gad & "):GADGET_LMBHOLDOFF"
    
    case GADGET_LMBRELEASE
      print pre & "(" & gad & "):GADGET_LMBRELEASE" 
      function=1
      
    case GADGET_LMBRELEASEOFF 
      print pre & "(" & gad & "):GADGET_LMBRELEASEOFF"
    
    case GADGET_LMBRELEASED
      print pre & "(" & gad & "):GADGET_LMBRELEASED"

'...oder reagieren auf ChildGadgets
    
    case GADGET_RUNTHROUGH
      print pre & "(" & gad & "):RUNTHROUGH"        

'folgende Aktionen werden immer bearbeitet:
    
    case GADGET_MOUSEHOVER 
      'print pre & "(" & gad & "):GADGET_MOUSEHOVER"           
    
    case GADGET_MOUSENEXT
      'print pre & "(" & gad & "):GADGET_MOUSENEXT"
    
    case GADGET_KEYBOARDON     
      print pre & "(" & gad & "):GADGET_KEYBOARDON"        
    
    case GADGET_KEYBOARD
      print pre & "(" & gad & "):GADGET_KEYBOARD :" & KEY    
    
    case GADGET_KEYBOARDOFF     
      print pre & "(" & gad & "):GADGET_KEYBOARDOFF"      
    
    case GADGET_WHEELMOVE
      print pre & "(" & gad & "):GADGET_WHEELMOVE :" & WHEEL   
      
  end select
end function


sub Button_Update(gad as Gadget ptr)
end sub


sub Button_Draw (gad as Gadget ptr)
	dim as integer GadWidth,GadHeight
	dim as FB.Image ptr Buffer

  GadWidth =gad->GadWidth
	GadHeight=gad->GadHeight
	Buffer   =gad->DrawBuffer->img
	'OFF 
	ClearBox Buffer,0,0,GadWidth,GadHeight
  'ON   unselect/select
  if gad->Activation then
    StdFilledBox Buffer,0,0,GadWidth,GadHeight,,,0,0
    drawstring (Buffer,1,1, "B")
  'SLEEP
		if gad->Activation=2 then Raster Buffer,0,0,GadWidth,GadHeight
	end if
end sub


'******************************************************************************
'******************************************************************************
'******************************************************************************


function AddString(win as sGUIWindow ptr,PosX as integer,PosY as integer) as Gadget ptr
	function=0  
	dim as Gadget ptr gad
	if win=0 then win=RootWindow
	gad=win->GadgetList->AppendNew (GadgetType)
	if gad then
		gad->parent=win
		gad->Selection=0
		gad->Activation=0
		gad->PosX=PosX
		gad->PosY=PosY
		gad->GadWidth=30
		gad->GadHeight=30 
    gad->DrawBuffer->img=imagecreate(gad->GadWidth,Gad->GadHeight)
		gad->DoDraw     =@String_Draw
		gad->DoAction   =@String_Actions'!!!
    gad->DoUpdate   =@String_Update'!!!
		function=gad
	end if
end function


function String_Actions(gad as Gadget ptr,action as integer) as integer
  function=0
  dim as string pre="String"

  select case action
'entweder direkte Gadget-MausKlick-Aktion...

    case GADGET_LMBHIT 
      print pre & "(" & gad & "):GADGET_LMBHIT"
      gad->KeyboardStream=1
      
    case GADGET_LMBHOLD 
      print pre & "(" & gad & "):GADGET_LMBHOLD"    
    
    case GADGET_LMBHOLDOFF 
      print pre & "(" & gad & "):GADGET_LMBHOLDOFF"
    
    case GADGET_LMBRELEASE
      print pre & "(" & gad & "):GADGET_LMBRELEASE" 
      
    case GADGET_LMBRELEASEOFF 
      print pre & "(" & gad & "):GADGET_LMBRELEASEOFF"
    
    case GADGET_LMBRELEASED
      print pre & "(" & gad & "):GADGET_LMBRELEASED"

'...oder reagieren auf ChildGadgets
    
    case GADGET_RUNTHROUGH
      print pre & "(" & gad & "):RUNTHROUGH"        

'folgende Aktionen werden immer bearbeitet:
    
    case GADGET_MOUSEHOVER 
      'print pre & "(" & gad & "):GADGET_MOUSEHOVER"           
    
    case GADGET_MOUSENEXT
      'print pre & "(" & gad & "):GADGET_MOUSENEXT"
    
    case GADGET_KEYBOARDON     
      print pre & "(" & gad & "):GADGET_KEYBOARDON"        
    
    case GADGET_KEYBOARD
      print pre & "(" & gad & "):GADGET_KEYBOARD :" & KEY    
    
    case GADGET_KEYBOARDOFF     
      print pre & "(" & gad & "):GADGET_KEYBOARDOFF"      
    
    case GADGET_WHEELMOVE
      print pre & "(" & gad & "):GADGET_WHEELMOVE :" & WHEEL   
      
  end select
end function


sub String_Update(gad as Gadget ptr)
  'einfachste Abbruchbedingung für den Textinput -> wenn irgendwo oder ein anderes Gadget angeklickt wurde
  if (FOCUSGADGET<>gad) then 
    gad->KeyboardStream=0
  end if
end sub


sub String_Draw (gad as Gadget ptr)
	dim as integer GadWidth,GadHeight
	dim as FB.Image ptr Buffer

  GadWidth =gad->GadWidth
	GadHeight=gad->GadHeight
	Buffer   =gad->DrawBuffer->img
	'OFF 
	ClearBox Buffer,0,0,GadWidth,GadHeight
  'ON   unselect/select
  if gad->Activation then
    StdFilledBox Buffer,0,0,GadWidth,GadHeight,,,0,0
    drawstring (Buffer,1,1, "S")
  'SLEEP
		if gad->Activation=2 then Raster Buffer,0,0,GadWidth,GadHeight
	end if
end sub
end namespace
