'Gadget/Window Extended Data
'gad->xtd. ...  win->xtd. ...

'WindowDragBar
type DRG_Data
	HitMouseX       as integer
	HitMouseY       as integer
	ScrMoveX        as integer
	ScrMoveY        as integer  
  ScrPosX         as integer
  ScrPosY         as integer
  oldWinSelection as integer
end type

'WindowCloseButton
type WCB_Data
  oldWinSelection as integer
end type

'SimpleGadget/ToggleGadget
type BTN_Data
  Fire as integer
  UseButtonColors as integer
  GadBody as ulong
  GadText as ulong
  GadBodySelected as ulong
  GadTextSelected as ulong
  BtnWindow as _sGUIWindow ptr
end type

'Arrow
type ARR_Data
	Direction 	as integer
	DelayState 	as integer
  DelayStart  as double
end type

'Label
type LBL_Data
	TextColor as ulong
end type

'RadioButton CheckMark
type RBC_Data
	KindOf				    as integer
	OffsetXDraw	      as integer
	OffsetYDraw       as integer
	OffsetXText		    as integer
	OffsetYText		    as integer
	TextLeftRight     as integer
  Radius            as integer
  DrawSize          as integer
	RBList				    as sGUIList ptr
  RTWindow          as _sGUIWindow ptr		
end type

'DropDownListBox
type DDL_Data
	WinExternal     as _sGUIWindow ptr
	ListBox         as _Gadget ptr
  SymbolGFXLayer  as _sGUIImage ptr  
  mode            as integer
end type

'ScrollBar Container
type SBC_Data
  ScrollValue 			as integer
	ScrollValueOld 		as integer
	ScrollValueMax		as integer
	ScrollValueMin		as integer
	PageSize					as integer
  FullRange         as integer  
  SlideSize         as integer
	KnobSize					as integer
	SwitchHV					as integer
	SwitchSlideMode		as integer
	KnobMouseOffset		as integer
	KnobPosition			as integer
  KnobGFXLayer      as _sGUIImage ptr
end type

'ScrollBar
type SCR_Data
	ScrollValue 			as integer
	ScrollValueOld 		as integer
	knobcontainer			as _Gadget ptr
	Arrowincr					as _Gadget ptr
	Arrowdecr					as _Gadget ptr
end type

'ListBox Selector
type LBS_Data
	DisplayMode	      as integer
	SelectionMode     as integer
	NumCharsPerRow		as integer'wird nicht mehr benutzt
	NumRows						as integer
	GapHorizontal			as integer
	GapVertical				as integer
	TopRow						as integer	
	SelectedRow				as integer
  HoveredRow        as integer
  oldHoveredRow     as integer
end type

'ListBox
type LBX_Data
	DisplayMode	      as integer
	SelectionMode     as integer	
	NumEntriesRef			as integer
  TimeStamp         as double
	selector				  as _Gadget ptr
	scrollbar					as _Gadget ptr	
end type

'Edit_Display
type EDD_Data
	Mode					    as integer'0= Edit StringGadget, 1=View StringGadget, 2=View StringGadget Datagrid, 10=Edit TextBox, 11=View TextBox
	CharsPerWidth     as integer'Anzeigebezogen: Wieviel Zeichen einer Zeile passen in die Breite der pixeldefinierten Box
	RowsPerHeight     as integer'Anzeigebezogen: Wieviel Zeilen passen in die Hhe der pixeldefinerten Box
	GapHorizontal			as integer
	GapVertical				as integer
	ScrollRow					as integer
	ScrollPosition		as integer
	CursorVisibility	as integer
end type

'String
type STG_Data
	Mode					      as integer'0=Edit,1=View,2=View DataGrid
	CharsPerWidth       as integer
	RowsPerHeight				as integer 
  MaxChars            as integer
  CharLimitation      as integer
  ShowEnd             as integer
  Focus               as integer
  TimeStamp           as double
	edit         			  as _Gadget ptr  
end type

'EditBox
type EDB_Data
	Mode					      as integer'0=Edit,1=View
	CharsPerWidth       as integer'PageSize horiz. Scrollbar
	RowsPerHeight				as integer'PageSize vert. Scrollbar   
  NumRows             as integer'Abgleich, bei Vernderungen im Text mu Update erfolgen
  LongestRow          as integer'"
  CursorRow           as integer'"
  CursorPos           as integer'"
  TimeStamp           as double
  scrollbarmodify     as integer
	edit         			  as _Gadget ptr
	vscroll 					  as _Gadget ptr
	hscroll 					  as _Gadget ptr  
end type

'FileRequester
type FRQ_Data
  Mode					    as integer
  RequestSuccess    as integer
  Separator         as integer
  btn_doit         	as _Gadget ptr
  btn_cancel        as _Gadget ptr
  lbl_file         	as _Gadget ptr
  stg_file         	as _Gadget ptr
  lbx_content       as _Gadget ptr
  btn_parent        as _Gadget ptr
  stg_path         	as _Gadget ptr
  frqWarnWindow     as _sGUIWindow ptr
end type

'Menu Gadgets
type MNG_Data
	MenuEntry           as _sGUIEntry ptr
	RBList				      as sGUIList ptr
  TimeStamp           as double  
end type

'Data Grid_Display
type DTD_Data
	ColumnList 	          as sGUIList ptr
  RowList 	            as sGUIList ptr
  CellHeight            as integer   
  InfoPosX              as integer
  InfoPosY              as integer
  InfoHeight            as integer
  GrdPosY               as integer
  GrdHeight             as integer
  InfoWidth             as integer 
  GrdPosX               as integer
  GrdWidth              as integer  
  'VP/virtueller Zeilen/Spalten ScrollCursor, ihm wird das Display, also VPTopRow/VPLeftColumn, nachgefhrt
  VPNumRows         as integer  
  VPTargetRow       as sGUIList ptr
  VPTargetRowIndx   as integer    
  VPTargetColumn    as _sGUIDGColumn ptr
  VPTargetColumnIndx  as integer  
  VPTopRow          as sGUIList ptr
  VPTopRowIndx      as integer               
  VPLeftColumn      as _sGUIDGColumn ptr
  VPLeftColumnIndx  as integer
  VPRightColumn     as _sGUIDGColumn ptr
  VPRightColumnIndx as integer   
  SelectionMode     as integer'0=No Selection, 1=Cell, 2=Row, 4=Column
  SelectedColumn    as _sGUIDGColumn ptr
  SelectedColumnIndx  as integer
  SelectedRow       as _sGUIList ptr
  SelectedRowIndx   as integer  
  SelectedCell      as _sGUIDGCell ptr
  EditMode          as integer'0=kein Edit, 1=Cell Edit, 2=Header Edit
  EditPosXglobal    as integer
  EditPosYglobal    as integer  
  TimeStamp         as double   
end type

'Data Grid
type DGR_Data
	ColumnList 	          as sGUIList ptr
  RowList 	            as sGUIList ptr
	ddisplay     			    as _Gadget ptr
	vscroll 					    as _Gadget ptr
	hscroll 					    as _Gadget ptr
	edit    		          as _Gadget ptr  
  TimeStamp             as double   
end type

'******************************************************************************
'******************************************************************************
'******************************************************************************

type ExtendedData
	EntryList					as sGUIList ptr
  TContainer			  as sGUIText ptr
	cstmdata          as any ptr
  union
		drg as DRG_Data
    wcb as WCB_Data
    btn as BTN_Data
		arr as ARR_Data
		lbl as LBL_Data
		rbc	as RBC_Data
		ddl	as DDL_Data
		sbc as SBC_Data
		scr as SCR_Data
		lbs as LBS_Data
		lbx as LBX_Data
		edd as EDD_Data
		edb as EDB_Data
    stg as STG_Data
    frq as FRQ_Data
    mng as MNG_Data
    dtd as DTD_Data
    dgr as DGR_Data
	end union
end type
